# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
# include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include <dirent.h>
#include "diaou_0.h"

/*################################################################*/
void DECODE1_ACCENTS(char s1[] )
	/***   decode accents in string s1    ***/
/*
 *    same as DECODE_ACCENT but will add unseparable space 
 *    after < and before >
 */
{
int i,j,l,ls,k,ii;
int ct ;/*  number of spaces for a tab */
char *ss,c;

l=strlen(s1);
if ( l == 0 ) return;
ii=0;
for(j=0;j < l ; ++j){
   if(s1[j] == '\t')++ii;
}/*for(j=0;j < l ; ++j){*/
ct = TAB;
if(ii != 0 ){
  ls = l + (ct-1)*ii+1;
  ss = g_malloc(ls*sizeof(char));
  j = 0 ;
  for(i=0 ; i <= l ; ++i ){
     if(s1[i] == '\t'){
	for (k = 0 ; k < ct ; ++ k){
	   *(ss+j) = ' ';
	   ++j;
	}/* for (k = 0 ; k < ct ; ++ k){*/
     }else{ /* if(s[i] == '\t'){*/
	*(ss+j) = s1[i];
	++j;
     } /* if(s[i] == '\t'){*/
  }/*  for(i=0 ; i <= l ; ++i ){*/
//     printf("ii=%d s1=%s@@@@ \n",ii,s1);
//     printf("ii=%d ss=%s@@@@ \n",ii,ss);
  strcpy(s1,ss);
//     printf("after  s1=%s@@@@ \n",s1);
  free(ss);
  l = strlen(s1);
}/*  if(ii != 0 ){*/
j=-1;
for( i =0 ; i<= l ; ++i){
   if( s1[i] != '\\' ){
       k= s1[i];
       if(k == 146 || k == -110) {/* problem of apostroph character */
	  s1[i]= 39;
	  k = 39;
       }/*if(k == 146 || k == -110) {*/
       if(k < -105){
	  if(k == -106 ) k=45;
	  if(k == -108 ) k=34;
	  if(k == -109 ) k=34;
	  if(k == -110 ) k=39;
	  if(k == -111 ) k=39;
	  s1[i] = k;
       }/*if(k < -105){*/
       if(k < 0) s1[i]= k+256; // Accentuated letters coded -128 +128
      c = s1[i];                                                                                
      ++j ;
      s1[j] = c ;
      k= (int) c;
       if(k < 0) k= k+256; // Accentuated letters coded -128 +128
//  171 = «  187 = »
//      if( i < l-1 && (c == '<' || c == 171 || c == '\"') && s1[i+1] == ' '){
      if( i < l-1 && (c == '<' || k == 171 || k == 147 || k == 34) && s1[i+1] == ' '){
         ++i; ++j ;
	 s1[j] = 160;
      }else{//if(c == '<' && i < l-1 && s1[i+1] == ' '){
       //if(i > 0 && (c == '>' || c == 187 || c == '\"' || c == '?' || 
         if(i > 0 && (c == '>' || k == 187 || k == 148 || k == 34 || c == '?' || \
	 c == '!' || c == ';' || c == ':') && s1[i-1] == ' '){
	    s1[j-1] = 160;
         }//if(c == '>' && i > 0 && s1[i-1] == ' '){
      }//if(c == '<' && i < l-1 && s1[i+1] == ' '){
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) TRO_ACCENT(&i,&j,s1) ;
   }/** end of if( s1[i] != '\\' ){   **/
	
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
}/** end of void DECODE_ACCENTS(char *s1[] )   ***/
/*################################################################*/
void SECURE_DECODE_ACCENTS(char **s1,long int *nbytes )
{/** start of void SECURE_DECODE_ACCENTS   ***/
int i,j,l,ls,k,ii;
int ct ;/*  number of spaces for a tab */
char *ss;

l=strlen(*s1);
if ( l == 0 ) return;
ii=0;
for(j=0;j < l ; ++j){
   if(*(*s1+j) == '\t')++ii;
}/*for(j=0;j < l ; ++j){*/
ct = TAB;
if(ii != 0 ){
  ls = l + (ct-1)*ii+1;
  ss = g_malloc(ls*sizeof(char));
  j = 0 ;
  for(i=0 ; i <= l ; ++i ){
     if(*(*s1+i) == '\t'){
	for (k = 0 ; k < ct ; ++ k){
	   *(ss+j) = ' ';
	   ++j;
	}/* for (k = 0 ; k < ct ; ++ k){*/
     }else{ /* if(s[i] == '\t'){*/
	*(ss+j) = *(*s1+i);
	++j;
     } /* if(s[i] == '\t'){*/
  }/*  for(i=0 ; i <= l ; ++i ){*/
//     printf("ii=%d s1=%s@@@@ \n",ii,s1);
//     printf("ii=%d ss=%s@@@@ \n",ii,ss);
  if(ls > *nbytes){
     *nbytes = ls + 25 ;
     *s1 = g_realloc(*s1, (*nbytes+5)*sizeof(char));
  }//if(ls > *nbytes)
  strcpy(*s1,ss);
//     printf("after  s1=%s@@@@ \n",s1);
  free(ss);
  l = strlen(*s1);
}/*  if(ii != 0 ){*/
j=-1;
for( i =0 ; i<= l ; ++i){
   if( *(*s1+i) != '\\' ){
       k= (int) *(*s1+i);
       if(k == 146 || k == -110) {/* problem of apostroph character */
	  *(*s1+i)= 39;
	  k = 39;
       }/*if(k == 146 || k == -110) {*/
       if(k < -105){
	  if(k == -106 ) k=45;
	  if(k == -108 ) k=34;
	  if(k == -109 ) k=34;
	  if(k == -110 ) k=39;
	  if(k == -111 ) k=39;
	  *(*s1+i) = (char) k;
       }/*if(k < -105){*/
       if(k < 0)  *(*s1+i) = (char) (k+256) ; // Accentuated letters coded -128 +128
      ++j ;
       *(*s1+j) =  *(*s1+i) ;
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) TRO_ACCENT(&i,&j,*s1) ;
   }/** end of if( s1[i] != '\\' ){   **/
	
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
}/** end of void SECURE_DECODE_ACCENTS   ***/
/*################################################################*/
void DECODE_ACCENTS(char s1[] )
	/***   decode accents in string s1    ***/
{
int i,j,l,ls,k,ii;
int ct ;/*  number of spaces for a tab */
char *ss;

l=strlen(s1);
if ( l == 0 ) return;
ii=0;
for(j=0;j < l ; ++j){
   if(s1[j] == '\t')++ii;
}/*for(j=0;j < l ; ++j){*/
ct = TAB;
if(ii != 0 ){
  ls = l + (ct-1)*ii+1;
  ss = g_malloc(ls*sizeof(char));
  j = 0 ;
  for(i=0 ; i <= l ; ++i ){
     if(s1[i] == '\t'){
	for (k = 0 ; k < ct ; ++ k){
	   *(ss+j) = ' ';
	   ++j;
	}/* for (k = 0 ; k < ct ; ++ k){*/
     }else{ /* if(s[i] == '\t'){*/
	*(ss+j) = s1[i];
	++j;
     } /* if(s[i] == '\t'){*/
  }/*  for(i=0 ; i <= l ; ++i ){*/
//     printf("ii=%d s1=%s@@@@ \n",ii,s1);
//     printf("ii=%d ss=%s@@@@ \n",ii,ss);
  strcpy(s1,ss);
//     printf("after  s1=%s@@@@ \n",s1);
  free(ss);
  l = strlen(s1);
}/*  if(ii != 0 ){*/
j=-1;
for( i =0 ; i<= l ; ++i){
   if( s1[i] != '\\' ){
       k= s1[i];
       if(k == 146 || k == -110) {/* problem of apostroph character */
	  s1[i]= 39;
	  k = 39;
       }/*if(k == 146 || k == -110) {*/
       if(k < -105){
	  if(k == -106 ) k=45;
	  if(k == -108 ) k=34;
	  if(k == -109 ) k=34;
	  if(k == -110 ) k=39;
	  if(k == -111 ) k=39;
	  s1[i] = k;
       }/*if(k < -105){*/
       if(k < 0) s1[i]= k+256; // Accentuated letters coded -128 +128
      ++j ;
      s1[j] = s1[i] ;
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) TRO_ACCENT(&i,&j,s1) ;
   }/** end of if( s1[i] != '\\' ){   **/
	
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
}/** end of void DECODE_ACCENTS(char *s1[] )   ***/
/*################################################################*/
void TRO_ACCENT(int *i, int *j ,char s1[] )
	/***   translation of accents according to code   ***/
	/**   \'e \`e \`a   .....     ***/
	/***   s1[i] = \     **/
{
int i1,i2,j1 ;

   i1= *i+1;
   i2=i1+1;	   
   if(s1[i1] == '~'){
        if(s1[i2]== 'n'){
	   *j = *j+1;
	   s1[*j] = 241 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i2]== 'N'){
	   *j = *j+1;
	   s1[*j] = 209 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/** end of if(s1[i1] == '~'){ **/
   if(s1[i2] == 'a'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 224 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 228 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '~'){
	   *j = *j+1;
	   s1[*j] = 227 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '\''){
	   *j = *j+1;
	   s1[*j] = 225 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 226 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'a'){  **/
   if(s1[i2] == 'e'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 232 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 234 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '\''){
	   *j = *j+1;
	   s1[*j] = 233 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 235 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'a'){/***   OK for ae   ***/
	   *j = *j+1;
	   s1[*j] = 230 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'o'){ /***  sorry not possible for oe ****/
	   *j = *j+1;
	   s1[*j] = 'o' ;
	   *j = *j+1;
	   s1[*j] = 'e' ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'e'){  **/
   if(s1[i2] == 'i'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 239 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 238 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'u'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 252 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 251 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 249 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'o'){
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 244 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 246 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'c'){
        if(s1[i1]== ','){
	   *j = *j+1;
	   s1[*j] = 231 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
                 /**/
    /**  Now for capital letters  **/
   if(s1[i1] == '~'){
        if(s1[i2]== 'N'){
	   *j = *j+1;
	   s1[*j] = 209 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i2]== 'N'){
	   *j = *j+1;
	   s1[*j] = 209 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/** end of if(s1[i1] == '~'){ **/
   if(s1[i2] == 'A'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 192 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 194 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'a'){  **/
   if(s1[i2] == 'E'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 200 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 202 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '\''){
	   *j = *j+1;
	   s1[*j] = 201 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 203 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'A'){/***   OK for ae   ***/
	   *j = *j+1;
	   s1[*j] = 198 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'O'){ /***  sorry not possible for oe ****/
	   *j = *j+1;
	   s1[*j] = 'O' ;
	   *j = *j+1;
	   s1[*j] = 'E' ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'e'){  **/
   if(s1[i2] == 'I'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 207 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 206 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'U'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 220 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 219 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 217 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'O'){
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 212 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 214 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'C'){
        if(s1[i1]== ','){
	   *j = *j+1;
	   s1[*j] = 199 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   *j = *j +1 ;
   j1 = *j ;
   s1[j1] = s1[*i] ;
   *i = *i +1 ;

}/** end of void TRO_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
char *CP_RM_ACCENTS(int code, char s1[] )
/*
 *   input s1 (that will not be changed) s1 is in CP1252 or \xx
 *   on output *s2 is created ; if code = 1 s2 if gone to lovercase
 *   if code = 0, any uppercase letter will not be changed
 */
{
int i,j,l,nb,ijump;
char k, *s2;

l=strlen(s1);
s2 = g_malloc((l+5)*sizeof(char));
strcpy(s2,s1);
/*printf("entree RM_ACCENTS l=%d s1=%s \n",l,s1);*/
if ( l == 0 ) return;
j=-1;
nb=0;
for( i =0 ; i<= l ; ++i){
   if( s2[i] != '\\' ){
      WORK_ACCENT(&i,&nb,s2);
      ++j ;
      s2[j] = s2[i] ;
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) WORK_RM_ACCENT(&i,&j,s2) ;
   }/** end of if( s1[i] != '\\' ){   **/
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
++j;
s2[j]='\0';
/*printf("sortie RM_ACCENTS nb=%d j=%d s1=%s \n",nb,j,s1);*/
if(nb == 0 ){
   if(code == 0)return (s2);
   for(i = 0 ; i < j ; ++i){
      *(s2+i) = tolower(*(s2+i));
   }//for(i = 0 ; i < j ; ++i){
   return(s2);
}//if(nb == 0 ){
/*
 *   We now have to remove ae and AE 8 bits coding
 *   However, in doing that, we increase the size of s2  !
 */
   i=j+nb;
   if(i > l){
      s2 = g_realloc(s2, (i+5)*sizeof(char));
   }//if(i > l){
   while(j >= 0){
      ijump=0;
      k=230;
      if( s2[j] == k){
	 s2[i]='e';
	 --i;
	 s2[i]='a';
	 ijump=1 ;
      }/*if( s2[j] == 230){*/
      k=198;
      if( s2[j] == k && ijump == 0){
	 s2[i]='E';
	 --i;
	 s2[i]='A';
	 ijump=1 ;
      }/*if( s2[j] == 230){*/
      --i;
      --j;
   }/*   end of while(j >= 0){   */
   if(code == 0)return (s2);
   for(i = 0 ; i < j ; ++i){
      *(s2+i) = tolower(*(s2+i));
   }//for(i = 0 ; i < j ; ++i){
   return(s2);
}/** end of void CP_RM_ACCENTS(char *s1[] )   ***/
/*################################################################*/
void RM_ACCENTS(char s1[] )
	/***   remove all the accents in string s1    ***/
	/***   this is useful to search the indexes   ***/
{
int i,j,l,nb,ijump;
char k ;

l=strlen(s1);
/*printf("entree RM_ACCENTS l=%d s1=%s \n",l,s1);*/
if ( l == 0 ) return;
j=-1;
nb=0;
for( i =0 ; i<= l ; ++i){
   if( s1[i] != '\\' ){
      WORK_ACCENT(&i,&nb,s1);
      ++j ;
      s1[j] = s1[i] ;
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) WORK_RM_ACCENT(&i,&j,s1) ;
   }/** end of if( s1[i] != '\\' ){   **/
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
++j;
s1[j]='\0';
/*printf("sortie RM_ACCENTS nb=%d j=%d s1=%s \n",nb,j,s1);*/
if(nb == 0 )return;
/*
 *   We now have to remove ae and AE 8 bits coding
 *   However, in doing that, we increase the size of s1  !
 */
   i=j+nb;
   while(j >= 0){
      ijump=0;
      k=230;
      if( s1[j] == k){
	 s1[i]='e';
	 --i;
	 s1[i]='a';
	 ijump=1 ;
      }/*if( s1[j] == 230){*/
      k=198;
      if( s1[j] == k && ijump == 0){
	 s1[i]='E';
	 --i;
	 s1[i]='A';
	 ijump=1 ;
      }/*if( s1[j] == 230){*/
      --i;
      --j;
   }/*   end of while(j >= 0){   */
}/** end of void RM_ACCENTS(char *s1[] )   ***/
/*################################################################*/
void WORK_RM_ACCENT(int *i, int *j ,char s1[] )
	/***  Remove the accents of accentuated lettrers        ***/
	/**   \'e /`e /`a   .....     ***/
	/***   s1[i] = \     **/
{
int i1,i2,j1 ;

   i1= *i+1;
   i2=i1+1;	   
   if(s1[i1] == '~' || s1[i1] == '`' || s1[i1] == '^' || s1[i1] == '\'' \
	      || s1[i1] == ':' || s1[i1] == ','){
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/** end of if(s1[i1] == '~'){ **/
   if(s1[i1] == 'a' && s1[i2] == 'e'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */
   if(s1[i1] == 'A' && s1[i2] == 'E'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */
   if(s1[i1] == 'o' && s1[i2] == 'e'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */
   if(s1[i1] == 'O' && s1[i2] == 'E'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */


   *j = *j +1 ;
   j1 = *j ;
   s1[j1] = s1[*i] ;
   *i = *i +1 ;

}/** end of void TRO_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
void WORK_ACCENT(int *i, int *nb ,char s1[] )
	/***  Remove the accents of accentuated lettrers        ***/
	/*   The accentuated letters are given by a single
	 *   8 bits code
	 */
	/**   \'e /`e /`a   .....     ***/
{
char kc;
int k;

kc=s1[*i];
k = kc;
/*printf("WORK_ACCENT i=%d kc=%c k=%d \n",*i,kc,k);*/
if(k < 0)k=k+256;
if(k < 198)return ;
if(k == 241){
   s1[*i] = 'n';
   return ;
}/*if(s1[i] == 241){*/
if(k == 231){
   s1[*i] = 'c';
   return ;
}/*if(s1[i] == 241){*/
if(k == 199){
   s1[*i] = 'C';
   return ;
}/*if(s1[i] == 241){*/
if(k == 209){
   s1[*i] = 'N';
   return ;
}/*if(s1[i] == 241){*/
if(k >= 224 && k <= 229){
   s1[*i] = 'a';
   return ;
}/*if(s1[i] == 241){*/
/*if(k == 226){
   s1[*i] = 'a';
   return ;
}*//*if(s1[i] == 241){*/
if(k == 232 || k == 234 || k == 233 || k == 235){
   s1[*i] = 'e';
   return ;
}/*if(s1[i] == 241){*/
if(k == 238 || k == 239 ){
   s1[*i] = 'i';
   return ;
}/*if(s1[i] == 241){*/
if(k == 206 || k == 207 ){
   s1[*i] = 'I';
   return ;
}/*if(s1[i] == 241){*/
if(k == 249 || k == 251 || k == 252){
   s1[*i] = 'u';
   return ;
}/*if(s1[i] == 241){*/
if(k == 217 || k == 219 || k == 220){
   s1[*i] = 'U';
   return ;
}/*if(s1[i] == 241){*/
if(k == 244 || k == 246 ){
   s1[*i] = 'o';
   return ;
}/*if(s1[i] == 241){*/
if(k == 212 || k == 214 ){
   s1[*i] = 'O';
   return ;
}/*if(s1[i] == 241){*/
if(k == 192 || k == 194 ){
   s1[*i] = 'A';
   return ;
}/*if(s1[i] == 241){*/
if(k == 200 || k == 201 || k == 202 || k == 203){
   s1[*i] = 'E';
   return ;
}/*if(s1[i] == 241){*/
if(k == 230){/*  code ae  */
   *nb = *nb + 1;
   return ;
}/*if(s1[i] == 241){*/
if(k == 198){/*  code AE  */
   *nb = *nb + 1;
   return ;
}/*if(s1[i] == 241){*/
/*
 *    Remark  codes oe and OE are unknown to me
 */
 

}/** end of void WORK_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
int POS_NALPHA(int l_dep, int l , char s[]) 
{
int i;

i=l_dep ;
//  printf("POS_NALPHA ");
while(i <=l ){
   if(!SPE_ALPHA_NUM(s[i]) && s[i] != ' ')return(i);
//   printf("%c",s[i]);
   ++i;
}/** end of while(i <=l && icode == 0){  **/
// printf("\n ");
return (i);
}/** end of POS_NALPHA  **/
/*################################################################*/
int SPE_ALPHA_NUM(char s1 )
/*
 *   Subroutine to detect special alphanumeric characters 
 *   which may be used into words. So we have also the
 *   accentuated letters. If s1 is acceptable, then 1 is
 *   returned.
 */ 
{
int k,rtn;

rtn = 1 ;
k = s1;
/*if(isalnum(s1)  || s1 =='-' \
   	 || s1 =='\'' || s1 == '\\'){*/
/*  for  WINDOWS only */
if((k >= 'a' && k <= 'z') || (k >= 'A' && k <= 'Z') \
		|| (k >= '0' && k <= '9')|| s1 =='-' \
   	 || s1 =='\'' || s1 == '\\'){
   return(rtn);
}
if(k < 0)k=k+256;
if(k == 241){
/*   s1[*i] = 'n';*/
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 231){
/*   s1[*i] = 'c';*/
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 199){
 /*  s1[*i] = 'C';*/
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 209){
/*   s1[*i] = 'N';   */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k >= 224 && k <= 229){
/*   s1[*i] = 'a';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 232 || k == 234 || k == 233 || k == 235){
/*   s1[*i] = 'e';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 238 || k == 239 ){
/*   s1[*i] = 'i';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 206 || k == 207 ){
/*   s1[*i] = 'I';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 249 || k == 251 || k == 252){
/*   s1[*i] = 'u';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 217 || k == 219 || k == 220){
/*   s1[*i] = 'U';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 244 || k == 246 ){
/*   s1[*i] = 'o';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 212 || k == 214 ){
/*   s1[*i] = 'O';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 192 || k == 194 ){
/*   s1[*i] = 'A';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 200 || k == 201 || k == 202 || k == 203){
/*   s1[*i] = 'E';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 230){/*  code ae  */
/*   *nb = *nb + 1;  */
   return(rtn) ;  
}/*if(s1[i] == 241){*/
if(k == 198){/*  code AE  */
/*   *nb = *nb + 1;  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
/*
 *    Remark  codes oe and OE are unknown to me
 */
rtn = 0 ;
return(rtn) ;
 

}/** end of void WORK_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
double DIFF_TIME_FILE(char name_file_origin[] , 
		                char name_file_derived[] )
/*
 *   Compute the difference between the time of last modification
 *   of two files given by their name . On return we have 
 *   deltat = time(name_file_derived) - time(name_file_origin)
 *   if deltat > 0  file_derived is younger than file_origin
 *   if file_origin does not exist the program stops. If file_derived
 *   does not exists deltat = -1 and a warning is printed
 */
{
   int i;	
   struct stat *stat_file ;
   time_t timer1, timer;
   double deltat;
   char ss[50],s_timer[50],s_timer1[50];

   stat_file = g_malloc(sizeof(struct stat));
/*   printf("sizeof=%d \n",sizeof(struct stat));
   printf("enter DIFF_TIME_FILE \n");
   printf("file_origin=%s@@@\n",name_file_origin);
   printf("file_derived=%s@@@\n",name_file_derived);*/
   
   i = stat(name_file_origin,stat_file);
   if( i >= 0){
//      printf("i=%d \n",i);
      timer1 = (*stat_file).st_mtime ;
      sprintf(s_timer1,"%s",asctime(localtime(&timer1)));
      printf("time of last modif %s = %s. \n",name_file_origin, \
		      s_timer1);
   }else{/* if(stat_file != NULL){*/
      printf("Error file %s  does not exist stop \n",name_file_origin);
      exit(1);
   }/* if(stat_file != NULL){*/
    
   i = stat(name_file_derived,stat_file);
   if(i >= 0){
//      printf("i=%d \n",i);
      timer = (*stat_file).st_mtime ;
      sprintf(s_timer,"%s",asctime(localtime(&timer)));
      printf("time of last modif %s = %s. \n", name_file_derived,\
		      s_timer);
      deltat = difftime(timer,timer1);
      sprintf(ss,"%e",deltat);
//      if(strstr(ss,"IND") != NULL) WINDOWS_DIFFTIME(&deltat,ss_timer,
//		      ss_timer1);
      WINDOWS_DIFFTIME(&deltat,s_timer, s_timer1);
      printf("after WINDOWS_DIFFTIME deltat=%e \n",deltat);

   }else{/* if(timer == NULL){*/
           printf("you need to create %s \n",name_file_derived);
	   deltat = -1;
   }/* if(timer == NULL){*/
   printf("diff time= %e \n",deltat);
   free( stat_file);
   return(deltat);
   }/* end of double DIFF_TIME_FILE  */ 
/*################################################################*/
 void   WINDOWS_DIFFTIME(double *deltat,char ss_timer[],\
		 char ss_timer1[])
/*  
 *    This sub has been introduced because under WINDOWS, the difftime
 *    function occasionaly does not work well ...
 *    We don't have here a true difftime. We return
 *               +1 if   timer younger than timer1
 *               0  if   timer = timer1
 *               -1 if   timer older than timer1
 *
 *           DDD MMM dd hh:mm:ss YYYY
 *           0  3   7  |  |  |  |    |
 *                     10 13 16 19   24
 */
{
//	char s_day[]="Sun,Mon,Tue,Wed,Thu,Fri,Sat,";
	char s_month[]="Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec,";
	char s[10], *sm_timer, *sm_timer1;
	int i,i1;
   printf("enter WINDOWS_DIFFTIME \n");
   printf("ss_timer=%s@@@\n",ss_timer);
   printf("ss_timer1=%s@@@\n",ss_timer1);
   i=atoi(ss_timer+19);
   i1=atoi(ss_timer1+19);
//   printf("timer_year=%d timer1_year=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
   memcpy(s,ss_timer+4,3);
   s[3]=',';
   s[4]='\0';
//   printf("s_month=%s@@@\n",s);
   if((sm_timer = strstr(s_month,s)) == NULL){
     printf("error sm_timer in WINDOWS_DIFFTIME stop \n");
     exit(5);
   }/*if((sm_timer = strstr(s_month,s)) == NULL){*/
   memcpy(s,ss_timer1+4,3);
   s[3]=',';
   s[4]='\0';
//   printf("s_month=%s@@@\n",s);
   if((sm_timer1 = strstr(s_month,s)) == NULL){
     printf("error sm_timer1 in WINDOWS_DIFFTIME stop \n");
     exit(5);
   }/*if((sm_timer = strstr(s_month,s)) == NULL){*/
   i=sm_timer-sm_timer1;
   if(i > 0){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < 0){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n day of month     */
   i=atoi(ss_timer+7);
   i1=atoi(ss_timer1+7);
//   printf("timer_nday=%d timer1_nday=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n hour of day     */
   i=atoi(ss_timer+11);
   i1=atoi(ss_timer1+11);
//   printf("timer_nhour=%d timer1_nhour=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n minute of hour     */
   i=atoi(ss_timer+14);
   i1=atoi(ss_timer1+14);
//   printf("timer_nminute=%d timer1_nminute=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n second of minute     */
   i=atoi(ss_timer+17);
   i1=atoi(ss_timer1+17);
//   printf("timer_nseconde=%d timer1_nseconde=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*   times are equal  */
   *deltat = 0.e+000;
}/*  end of WINDOWS_DIFFTIME  */
/*################################################################*/
int EXTR_N_INT(int n,char *s,int i_extracted[])
/*
 *   Extract n int dans *s  
 *   Il n'y a que des int et des blancs en debut de chaine
 *   We return as int the number j   *(s+j) is the character after
 *   the n  int + the blancs
 */
{
int i1,l,j,k;
char s1[101],c;
   
   l=strlen(s);
   j=0;
   i_extracted[0] = 0;
   while(j < l && *(s+j)== ' ')++j;
   c = *(s+j) ;
   if(j > l || ( !isdigit(c) && c != '.' && c != '+' && c != '-'  ))return(j);
      i1=1;
      while(j < l && i1 <= n ){
	 k=0;
	 while(j < l && isdigit(*(s+j))){
	    s1[k]=*(s+j);
	    ++k;
	    ++j;
	 }/*while(j < l && s[j] != ' '){*/
	 s1[k]='\0';
/*	 printf("EXTR_N_INT level 1 j=%d  s1=%s@@@ \n",j,s1);
	 fflush(stdout);*/
	 i_extracted[i1]=atoi(s1);
//		printf("i1=%d s1=%s xx1=%15.8f \n",i1,s1,xx1);
         ++i1;
         while(j < l && *(s+j)== ' ')++j;
/*	 printf("EXTR_N_INT level 2 j=%d   \n",j);
	 fflush(stdout);*/
      }/*for(i1=1;i1 <= n ; ++i1){*/
//      printf("i1 = %d \n",i1);
   i_extracted[0] = i1-1;
   return(j);
}
/*################################################################*/
int EXTR_N_LINT(int n,char *s,long int i_extracted[])
/*
 *   Extract n long int from *s  
 *   Il n'y a que des long int et des blancs en debut de chaine
 *   We return as int the number j   *(s+j) is the character after
 *   the n long int + the blancs
 */
{
int i1,l,j,k;
char s1[101],c;
   
   l=strlen(s);
   j=0;
   i_extracted[0] = 0;
   while(j < l && *(s+j)== ' ')++j;
   c = *(s+j) ;
   if(j > l || ( !isdigit(c) && c != '.' && c != '+' && c != '-'  ))return(j);
      i1=1;
      while(j < l && i1 <= n ){
	 k=0;
	 while(j < l && *(s+j) != ' '){
	    s1[k]=*(s+j);
	    ++k;
	    ++j;
	 }/*while(j < l && s[j] != ' '){*/
	 s1[k]='\0';
	 i_extracted[i1]=atol(s1);
//		printf("i1=%d s1=%s xx1=%15.8f \n",i1,s1,xx1);
         ++i1;
         while(j < l && *(s+j)== ' ')++j;
      }/*for(i1=1;i1 <= n ; ++i1){*/
//      printf("i1 = %d \n",i1);
   i_extracted[0] = i1-1;
   return(j);
}

/**********************************************************************/
long int aln_getline(long int *nc,char **ss,long int *nbytes, FILE *fp)
/*
 *    nbytes is the present memory size for the string ss
 *    returns -2 if EOF
 *    return -1 and nc= NULL if was not able to read in the file
 *    returns tro the number of characters which are in the line
 *    *(*ss+tro)= '\0';
 *    This sub will realloc ss but does not alloc it
 *    It seems that on linux text files we have only a \n character 
 *    at the end of each line
 *    For Windows text files we have \r\n
 *    This sub should read nicely a line on Windows or Linux text files
 *    It should have no problems with Mac files which have only \r
 *    It will return nc
 *    Detection of utf8 lines is automatic. These lines are translated
 *    into Windows latin : CP1252  (with French oe)
 *    On entrance nc is the position to start reading
 *    On output  nc is the position to start next reading
 *    \r = 13  \n = 10
 *    The problem is that on Windows we read \r\n as \n and fgets
 *    is advancing of 2 places. Then there is a difference between
 *    ftell and our counting inc
 *    There is perhaps a problem with empty lines 
 */
{/*=======================================================*/
char c;
long int tro,i,inc, n;
int ok,k,km,iso,utf,ic,is ;
char *st_line;

/*   printf("enter aln_getline nc=%ld \n",*nc);
   fflush(stdout);*/
   iso = 0 ;
   utf = 0 ;
   tro=-1;
   inc= *nc;
   if(fseek(fp,*nc,0) != 0){ ;// on success it return 0
      nc = NULL;
      **ss = '\0';
      return(tro);
   }//if(fseek(fp,*nc,0)== NULL){ ;
   c=fgetc(fp);
/*   printf("enter aln_getline nc=%ld (int) c=%d ftell=%ld \n",*nc, (int) c,ftell(fp));
   fflush(stdout);*/
   if(c == EOF){// for an error or truly end of file
      **ss = '\0';
      tro = -2;
      //  In that case we don't change nc
      return(tro);
   }/*if(c == EOF){*/
   i = 0;
//   while(c != '\0' && c != EOF && c != '\n' && c != NULL){
#if WINDOWS
char cc;
int ic1 ;
   if(c == '\n'  ){
      inc = ftell(fp);
/*      printf("aln_getline win return /n empty line nc=%ld ftell=%ld \n",*nc,inc);
      fflush(stdout);*/
      **ss = '\0';
      tro = 0;
      *nc = *nc + 1 ;
      if(inc > *nc)*nc = *nc+1 ;
      return(tro);
   }//if(c == '\n' ){
/*
*   It seems that on windows we have series \r\n\n 
*/
   if( c == '\r'  ){
    inc = ftell(fp) ;
/*      printf("aln_getline win return /r empty line nc=%ld ftell=%ld \n",*nc,inc);
      fflush(stdout);*/
      inc = *nc + 1;  
      fseek(fp,inc,0);
      cc=fgetc(fp);
      ic1 = (int )cc ;
      if(ic1 == 10){
         *nc = *nc + 2 ;
         fseek(fp,*nc,0);
         cc=fgetc(fp);
         ic1 = (int )cc ;
         if(ic1 == 10)*nc = *nc + 1 ;
      }else{//if(ic1 == 10)
         *nc = *nc + 1 ;
      }//if(ic1 == 10)
      **ss = '\0';
      tro = 0;
      return(tro);
   }//if(c == '\r' )
#endif
#if LINUX
   if(c == '\n' ){
      inc = *nc+1;
      *nc= inc ;
      tro = 0;
      **ss = '\0';
/*      printf("aln_getline return 11 empty line nc=%ld \n",*nc);
      fflush(stdout);*/
      return(tro);
   }//if(c == '\n' ){
   if(c == '\r' ){
      while(c == '\r' ){
         inc = ftell(fp);
         c=fgetc(fp);
      }//while(c == '\r' ){
      if(c == '\n' )++inc; // modif 13 Oct 2011
//      while(c == '\n' )++inc;
      *nc = inc ;
      tro = 0;
      **ss = '\0';
/*      printf("aln_getline return 12 empty line nc=%ld \n",*nc);
      fflush(stdout);*/
      return(tro);
   }//if(c == '\n' ){
#endif
   ++inc;
   while( c != EOF && c != '\n' && (int) c != 13){
      is = 1 ;
      if(c == '\t') is = TAB ;
      if(i + is >= *nbytes){
         *nbytes = *nbytes + TAB + 100;
	 n= *nbytes+5;
//	 printf("realloc *nbytes=%ld n=%ld \n",*nbytes,n);
	 *ss = realloc(*ss, n*sizeof(char));
      }/*if(i >= nbytes){*/
      if(c == '\t'){
         for(k = 1 ; k <= TAB ; ++k){
            *(*ss+i) = ' ';
            ++i;
         }//for(k = 1 ; k <= TAB ; ++k){
      }else{//if(c == '\t'){
         if( c != '\0') {//13 is \r  character on a windows text file
//  The '\0' character should not be on a text file but...
            *(*ss+i) = c;
            ++i;
         }/*if(c != 13) {*/
      }//if(c == '\t'){
      ic = (int) c; if(ic < 0)ic = ic+256;
/*      printf("aln_getline inc=%ld c=%c  ic=%d \n",inc,c,ic);
      fflush(stdout);*/

      km = 0;
      if(ic >= 192){
         if( ic < 224){
	    km = 1 ;
         }else{//if( c < 224){
	    if(ic < 240){
	       km = 2 ;
	    }else{//if(c < 240){
	       if(ic < 248){
	          km = 3 ;
	       }else{//if(c < 240){
	          km = 0 ;
		  iso = 1 ;
	       }//if(c < 240){
	    }//if(c < 240){
         }//if( ic < 224){
      }//if(c >= 192){
      c=fgetc(fp);
      ++inc;
/*      printf("next inc=%ld c=%c  ic=%d km=%d \n",inc,c, (int) c,km);
      fflush(stdout);*/
      if(km > 0){
/*       printf("aln_getline km=%d ic1=%d c=%c@@@ \n",km, (int) c , c);
         fflush(stdout);*/
         k = 1 ;
	 ok = 1;
         while(ok == 1 && c != '\0' && c != EOF && c != 10 && c != 13 && k <= km){
            if( c != '\0') {//13 is \r  character on a windows text file
//           The '\0' character should not be on a text file but...
               *(*ss+i) = c;
               ++i;
            }/*if(c != 13) {*/
            ic = (int) c; if(ic < 0)ic = ic+256;
/*          printf("k=%d c=%c  ic=%d \n",k,c,ic);
            fflush(stdout);*/
	    if(!(ic >= 128 && ic < 192))ok = 0;
	    ++k ;
            c=fgetc(fp);
	    ++inc;
         }//while(c != '\0' && c != EOF && k <= km){
	 if(k <= km)ok = 0;
	 if(ok == 0){
	    iso = 1;
	 }else{//if(ok == 0){
	    utf = 1;
	 }//if(ok == 0){
      }//if(km > 0){

   }/*while(c != '\0' && c != EOF ){*/
/*  printf("aln_getline out of while inc=%ld iso=%d  utf8=%d \n \n",inc,iso,utf);
            fflush(stdout);*/
   if( utf == 1){
      if(iso == 1){
         *(*ss+i)= '\0';
         printf("aln_getline bad mixture of iso and utf8 \n ss=%s@@@\n",*ss);
            fflush(stdout);
      }else{//if(iso == 1){
         *(*ss+i)= '\0';
/*         printf("aln_getline  utf=1 ss=%s@@@\n",*ss);
            fflush(stdout);*/
//         st_line = g_convert(*ss,-1,"ISO-8859-15","UTF-8",NULL,NULL,NULL);
         st_line = g_convert(*ss,-1,"CP1252","UTF-8",NULL,NULL,NULL);
/*         printf("aln_getline  st_line=%s@@@\n",st_line);
            fflush(stdout);*/
	 if(st_line != NULL){
	    strcpy(*ss,st_line);
	    g_free(st_line);
	 }else{//if(st_line != NULL){
//	    strcpy(*ss,"???? !!! ");
	 }//if(st_line != NULL){
/*         printf("aln_getline  utf8 line \n ss=%s@@@\n",*ss);
            fflush(stdout);*/
	 i= strlen(*ss);
      }//if(iso == 1){
   }else{//if( utf == 1){
      *(*ss+i)= '\0';
//      printf("aln_getline  iso line \n ss=%s@@@\n",*ss);
   }//if( utf == 1){
//   ncm = ftell(fp);
/*      printf("alngetline level 1 inc=%ld ftell=%ld c=%c  ic=%d  \n",inc,ftell(fp),c, (int) c);
      fflush(stdout);*/
   tro = i ;
   *(*ss+i)= '\0';
   ic = (int )c;
#if WINDOWS
char c1 ;
/*   printf("aln_getline windows  sortie fin inc=%ld ftell=%ld ic=%d ss=%s@@@ \n",inc,ftell(fp),ic,*ss);*/
   if(ic == 10 ){
      *nc = inc ;
      fseek(fp,*nc,0);
      cc=fgetc(fp);
      ic1 = (int )cc ;
      if(ic1 != 10 && ic1 != 13)return(tro);
      *nc = inc+1 ;
 //       printf("sortie fin ic = 10  nc=%ld  ftell=%ld \n",*nc,ftell(fp));
         return(tro);
   }//if(ic == 10){
   if(ic == 13 ){
      *nc = inc+1 ;
      fseek(fp,*nc,0);
      cc=fgetc(fp);
      ic1 = (int )cc ;
      if(ic1 != 10 && ic1 != 13)return(tro);
      *nc = inc+2 ;
         fseek(fp,*nc,0);
         cc=fgetc(fp);
         ic1 = (int )cc ;
         if(ic1 == 10)*nc = *nc + 1 ;
      return(tro);
   }//if(ic == 13)
#endif

#if LINUX
   if(c == '\n' ){
      *nc= inc ;
      tro = 0;
/*      printf("aln_getline return 21 linux nc=%ld \n",*nc);
      fflush(stdout);*/
      return(tro);
   }//if(c == '\n' ){
   if(c == '\r' ){
      while(c == '\r' ){
         inc = ftell(fp);
         c=fgetc(fp);
      }//while(c == '\r' ){
      if(c == '\n' )++inc;
      *nc = inc ;
      tro = 0;
/*      printf("aln_getline return 22 linux nc=%ld \n",*nc);
      fflush(stdout);*/
      return(tro);
   }//if(c == '\n' ){
#endif
//  printf("aln_getline return direct nc=%ld ss=%s@@@ \n",*nc,*ss);

/*    printf("aln_getline return 3 nc=%ld ss=%s@@@ \n",*nc,*ss);
      fflush(stdout);*/
   *nc = inc;
   return(tro);
}/*=======================================================*/
/*################################################################*/
   char *RM_PATH_FROM_STRING(char path[])
/*
 *    On output this function gives the filename 
 *    extracted from the path which is in a character string
 */
 {
    int l,i,j,ll;
    char *s ;

    l = strlen(path);
//    printf("path=%s@@@@  path[l-1]=%c \n",path,path[l-1]);
    if(l <= 0 ) return(NULL);
    j = l-1 ;
    while( j >= 0 && path[j] != '/')--j;
    ll=l-j+4;
    s = g_malloc( ll*sizeof (char));
  /*  s = malloc( sizeof (char) * (l+1));*/
    i= 0 ;
    if(j < 0){
       strcpy(s,"./");
       i=2;
    }/*if(j < 0){*/
    strcpy(s,"&/");
    i=2;
    for (j = j+1  ; j <= l ; ++j){
       s[i] = path[j];
       ++i ;
    }/* end of for (j ; j <= l ; ++j){*/
    s[i] = '\0';
//    printf("in RM_PATH_FROM_STRING s=%s@@@ \n",s);
    if(i+1 > ll){
       printf("in RM_PATH_FROM_STRING error mem STOP \n");
       exit(90);
    }/*if(i+1 > ll){*/
    return(s);
 }/* end of  char *filename_from_path(char path[])*/
 /*################################################################*/
   char *SHIFT_PATH_COND(char *s_shift,char *string)
/*
 *    On output this function gives the path of a file
 *    but with the shift s_shift when string is a relative path
 */
 {
 int i,j,k,ii,jj,l,ls,lt ;
 char *s ;
    l = strlen(string);
    if(s_shift == NULL ||(ls = strlen(s_shift)) == 0){
       lt = l+5;
       s = g_malloc( lt*sizeof (char));
       strcpy(s,string);
       return(s);
    }//if(s_shift == NULL ||(ls = strlen(s_shift)) == 0){
/*
 *   conditioning of string
 */
    ii = 0 ;
    while(ii < l && *(string+ii) == ' ')++ii;
    if(ii >= l ){
       l= 0 ;
       *(string+l) = '\0';
       ii = 0 ;
    }else{//if(ii >= l ){
       jj = l -1 ;
       while(jj >= 0 && *(string+jj) == ' ')--jj ;
       l = jj+1 ;
       *(string+l) = '\0';
       k = 0;
       while(ii <= l ){
          *(string+k) =  *(string+ii);
          ++ii ; ++k;
       }//while(ii <= l ){
       l = k-1 ;
    }//if(ii >= l ){
/*
*   case string is an absolute path
*/
    if( *(string) == '/' ||  \
                  (isupper(*(string)) && *(string+1) == ':')  ){
       lt = l+5;
       s = g_malloc( lt*sizeof (char));
       strcpy(s,string);
       return(s);
    }//if( *(string) == '/' ||  
/*
 *   conditioning of s_shift
 */
    i = 0 ;
    while(i < ls && *(s_shift+i) == ' ')++i;
    j = ls -1 ;
    while(j >= 0 && *(s_shift+j) == ' ')--j ;
    if( *(s_shift+j) == '/' )--j;
    ls = j+1 ;
    *(s_shift+ls) = '\0';
//
    lt = ls - i + 1 + l + 5 ;
    s = g_malloc( lt*sizeof (char));
    strcpy(s,s_shift+i);
    strcat(s,"/");
    if(*(string)== '.' && *(string+1) == '/' ){
       strcat(s,string+2);
    }else{//if(*(string)== '.' && (*(string+1) == '/' ){
       strcat(s,string);
    }//if(*(string)== '.' && (*(string+1) == '/' ){
    return(s);
 }
/*################################################################*/
   char *PATH_FROM_STRING(char *string)
/*
 *    On output this function gives the path 
 *    extracted from the character string
 *    which is the full path+file_name
 */
 {
    int l,i,j,j1,k,ll;
    char *s,c ;

    l = strlen(string);
    j1 = 0;
    while(j1 < l && *(string+j1) == ' ')++j1;
//    printf("string=%s@@@@  string[l-1]=%c \n",string,string[l-1]);
    if(l <= 0 ) return(NULL);
    j = l-1 ;
    while( j >= 0 && (c = *(string+j)) != '/' &&  c != '\\')--j;
    ll=j+4;
    s = g_malloc( ll*sizeof (char));
  /*  s = malloc( sizeof (char) * (l+1));*/
    if(j < j1){
       strcpy(s,"./");
       return(s);
    }/*if(j < 0){*/
    i= 0 ;
    c = *(string+j1);
    if( c != '.' && c != '/' && c != '\\' \
                  && !(isupper(c) && *(string+j1+1) == ':')  ){
       strcpy(s,"./");
       i = 2 ;
    }//if( c != '.' && c != '/' && c != '\\'  ){
    k = j1;
    while (  k <= j ){
       c = *(string+k);
       if(c == '\\')c= '/';
       *(s+i) = c;
       ++i;
       ++k;
    }/* end of for (j ; j <= l ; ++j){*/
    s[i] = '\0';
    printf("in PATH_FROM_STRING string=%s@@@ path=%s@@@ \n",string,s);
    return(s);
 }/* end of  char *filename_from_path(char path[])*/
/*################################################################*/
   char *FILE_NAME_FROM_STRING(char *string)
/*
 *    On output this function gives the filename 
 *    extracted from the full path which is in a character string
 */
 {
    int l,i,j,ll;
    char *s,c ;

    l = strlen(string);
//    printf("path=%s@@@@  path[l-1]=%c \n",path,path[l-1]);
    if(l <= 0 ) return(NULL);
    j = l-1 ;
    while( j >= 0 && (c = *(string+j)) != '/' &&  c != '\\')--j;
    ll=l-j+4;
    s = g_malloc( ll*sizeof (char));
  /*  s = malloc( sizeof (char) * (l+1));*/
    i= 0 ;
    for (j = j+1  ; j <= l ; ++j){
       c = *(string+j);
       if(c == '\\')c= '/';
       *(s+i) = c;
       ++i ;
    }/* end of for (j ; j <= l ; ++j){*/
    *(s+i) = '\0';
//    printf("in RM_PATH_FROM_STRING s=%s@@@ \n",s);
//    printf("in FILE_NAME_FROM_STRING string=%s@@@ file_name=%s@@@ \n",string,s);
    return(s);
 }/* end of  char *filename_from_path(char path[])*/
/*################################################################*/
void  RM_EXTRA_BLANCS(char *s)
/*
 *    in string s  no more than 1 blanc in a pack of blancs
 *    example   word1   word2 word3   becomes
 *              word1 word2 word3
 *    You can have blancs before word1 and after word3
 *    they will be reduced if necessary to 1 unit.
 */
{ /*  begins RM_EXTRA_BLANCS */
   int i,j,l;

// printf("input  RM_EXTRA_BLANCS s=%s@@@\n",s);
   j= 0;
   i= 0;
   l= strlen(s);
   if(*(s) == ' '){
      ++j;
      while(*(s+i) == ' ')++i;
   }/* end if(s[0] == ' '){  */
   while(i < l){
//      printf("loop while 1 s=%s@@@ \n",s);
      while(i<l && *(s+i) != ' '){
//	 printf("i=%d *(s+i)=%c \n",i,*(s+i));
	 *(s+j) = *(s+i) ;
	 ++j;
	 ++i;
      }/* while(i<l && s[i] != ' '){*/
// printf("level 1RM_EXTRA_BLANCS s=%s@@@\n",s);
      
      if(i < l && *(s+i) == ' '){
	 ++i;
	 *(s+j) = ' ';
	 ++j;
	 while(i < l && s[i] == ' ')++i;
      }/*  end if(i , l && s[i] == ' '){*/
   }/*while(i < l){*/
   *(s+j) = '\0';
// printf("output RM_EXTRA_BLANCS s=%s@@@\n",s);
} /*  ends RM_EXTRA_BLANCS */
/*################################################################*/
void  RM_ALL_BLANCS(char *s)
/*
 *    in string s  all blancs are removed
 *    example   word1   word2 word3   becomes
 *              word1word2word3
 */
{ /*  begins RM_ALL_BLANCS */
   int i,j,l;
   char c ;

// printf("input  RM_EXTRA_BLANCS s=%s@@@\n",s);
   j= 0;
   i= 0;
   l= strlen(s);
      while(i < l ){
//	 printf("i=%d *(s+i)=%c \n",i,*(s+i));
	 if((c = *(s+i) ) != ' '){
            *(s+j) = c ;
	    ++j;
	 }//if((c = *(s+i) ) != ' ')
	 ++i;
      }/* while(i<l && s[i] != ' '){*/
   *(s+j) = '\0';
// printf("output RM_ALL_BLANCS s=%s@@@\n",s);
} /*  ends RM_ALL_BLANCS */
/*################################################################*/
void  RM_START_BLANCS(char *s)
/*
 *    in string s  the blancs at the begining are removed
 */
{ /*  begins RM_START_BLANCS */
   int i,j,l;

// printf("input  RM_START_BLANCS s=%s@@@\n",s);
   j= 0;
   i= 0;
   l= strlen(s);
      while(i<l && *(s+i) == ' ')++i;
      if(i == 0)return;
      while(i<l ){
//	 printf("i=%d *(s+i)=%c \n",i,*(s+i));
	 *(s+j) = *(s+i) ;
	 ++j;
	 ++i;
      }/* while(i<l && s[i] != ' '){*/
   *(s+j) = '\0';
// printf("output RM_START_BLANCS s=%s@@@\n",s);
} /*  ends RM_START_BLANCS */
/*################################################################*/
void  LNB_12CHAR(long int nb,char *snb)
/*
 *    Writes a long integer into 12 characters
 */
{//============  start LNB_12CHAR  ========================
char sw[26];
int i,j,l,dd;
/*   printf("enter LNB_12CHAR nb=%ld   \n",nb);
   fflush(stdout);*/
   sprintf(sw,"%ld",nb);
/*   printf("LNB_12CHAR sw=%s@@@@   \n",sw);
   fflush(stdout);*/
   l=strlen(sw);
   dd=(12-l)/2;
/*   printf("LNB_12CHAR dd=%d   \n",dd);
   fflush(stdout);*/
   if(dd < 0){
      printf("Warning LNB_12CHAR sw=%s@@@\n",sw);
      sw[12]='\0';
      dd=0;
      l=12;
   }//if(dd < 0){
   j=0;
   for(i = 0 ; i < dd ; ++i){
     *(snb+j) = ' ';
     ++j;
   }//for(i = 0 ; i < dd ; ++i){
   *(snb+j) = '\0';
/*   printf("LNB_12CHAR level 1 snb=%s@@@@   \n",snb);
   fflush(stdout);*/
   i=0;
   for(i=0 ;i < l ; ++i ){
     *(snb+j) = sw[i];
     ++j;
   }//while(i < l){
   while(j < 12){
     *(snb+j) = ' ';
     ++j;
   }//while(i < l){
   j=12;
   *(snb+j) = '\0';
/*   printf("LNB_12CHAR nb=%ld  snb=%s@@@@ \n",nb,snb);
   fflush(stdout);*/
}//============  start LNB_12CHAR  ========================
/*################################################################*/
long int  DIFF_JOUR()
/*
 * Calcul du nombre de jours depuis le 1er janvier 2001
 */
/*
time_t timer;
struct tm t_local;
      timer = time(NULL);
      t_local = *localtime(&timer);
      int yy = (t_local).tm_year+1900;
      sprintf(s_bmp,"E:\\Dev-Cpp\\kuzhet\\sk%4d%2d%2d_%2d%2d%2d.jpeg",yy,\
          t_local.tm_mon+1,t_local.tm_mday,t_local.tm_hour,\
	  t_local.tm_min,t_local.tm_sec);*/
{//==========   Start   DIFF_JOUR  ===========================
     time_t  timer;
     struct tm ptime;
     int an,ms,jr;
     double njul, cjul ;
     long int  diff_jour;

        timer = time(NULL) ;// present time
	ptime = *localtime(&timer);
	an = 1900 + ptime.tm_year ;
	ms = 1 + ptime.tm_mon;
	jr = ptime.tm_mday ;
	njul = Julien(an,ms,jr);
/*
 *   calcul du jour julien du 21 eme siecle (1 janvier 2001)
 */
       an = 2001 ;
       ms = 1 ;
       jr = 1;
       cjul = Julien(an,ms,jr);
       diff_jour = njul-cjul;
       return(diff_jour);
       
}//==========   END   DIFF_JOUR  ===========================
/*################################################################*/
    //--------------------------------------------------------------------
    double Julien(int an, int ms, int jr)
    {
      // Returne le nombre de jours Juliens
      double jd;
      jd = (1461 * (an + 4800 + (ms -14) / 12)) / 4;
      jd += (367 * (ms - 2 - 12 * ((ms - 14) / 12))) / 12;
      jd -= (3 * ((an + 4900 + (ms - 14) / 12) / 100)) / 4;
      jd += jr;
      return jd;
    }
   //----------------------------------------------------------------------
/*################################################################*/
  
   double Julian(int year,int month,double day)
   {
     // Returns the number of julian days for the specified day.
  
       int a,b,c,e;
       if (month < 3) {
          year--;
          month += 12;
       }
       if (year > 1582 || (year == 1582 && month>10) ||\
           (year == 1582 && month==10 && day > 15)) {
          a=year/100;
          b=2-a+a/4;
       }
       c = 365.25*year;
       e = 30.6001*(month+1);
       return b+c+e+day+1720994.5;
   }
   //---------------------------------------------------------------------------
/*################################################################*/
/*********************************************************************
 *
 * Purpose: Demonstrate the 'srand' and 'rand' functions
 * Author:  M.J. Leslie.
 * Date:    11=Nov-94
 *
 *********************************************************************/
/*
#include <time.h>
#include <stdlib.h>

main()
{
  int rolls=4;*/
					/* This looks DISCUSTING!
					 * time returns a different value 
					 * on every execution. And so 
					 * changes the value passed to 
					 * srand. See CAST
					 * for an explanation of 
					 * (unsigned int) and (time_t)	*/
  //srand((unsigned int)time((time_t *)NULL));

					/* Roll the dice.		*/
 /* while(rolls--)
  {
    printf("Dice value is %d\n", (rand()%6)+1);
  }
}
*/
/*##################################################################*/
void  RESIZE_STRING(int lssd, char *ss)
/*
 *    Resizing of the string ss, adding or removing blancs
 * ss is a string of the kind :
 *        1      ;     1      ;    3244    ;     0      ;     0      ;    3244    ;
 */
{//==========Start of RESIZE_STRING===============================
 int i,j,k,kk,l ;
 int iblanc;
    l= strlen(ss);
    if(l == lssd)return;
    if(lssd > l){
       for(i = l ; i < lssd ; ++i)*(ss+i)=' ';
       *(ss+lssd)= '\0';
       return;
    }//if(lssd > l){
/*
 *   Here we have the difficult case lssd < l
 *   we must remove blancs in ss but still let
 *   a single blanc as separator before and after the non blancs
 *   characters
 */
   kk = l -lssd ;
   i = 0 ;
   j = 0 ;
   k = 0;
   iblanc = 0;
   while(i < l && k < kk){
      if(*(ss+i) != ' '){
         iblanc = 0 ;
	 if(j != i)*(ss + j) = *(ss+i);
	 ++j ;
      }else{//if(*(ss+i) != ' '){
          if(iblanc == 1){
	     ++k;
          }else{//if(iblanc == 1){
	     if(j != i)*(ss + j) = *(ss+i);
	     ++j ;
          }//if(iblanc == 1){
	  iblanc = 1;
      }//if(*(ss+i) != ' '){
      ++i;
   }//while(i >= 0 && k < j){
   while(i < l && j < lssd ){
      if(j != i)*(ss + j) = *(ss+i);
      ++j ;
      ++i;
   }//while(i < l){
   if(j != lssd){
      printf("error RESIZE_STRING j=%d lssd=%d \n",j,lssd);
   }//if(j != lssd){
   *(ss+lssd) = '\0';
}//==========End of RESIZE_STRING=================================
/*################################################################*/
/*    Il n'existe pas en C de fonction réalisant la copie d'un fichier. 
 *    Il est donc nécessaire de créer une fonction lisant le fichier
 *    pour le copier dans le fichier de destination.
 *    trouve dans
 *    http://c.developpez.com/faq/?page=fichiers#FICHIERS_sup_ligne

#include <stdio.h>
          return 0    copie ok
	  return 1    pas de fichier source
	  return 2    impossible ouvrir le fichier destination
*/
int copier_fichier(char const * const source0, char const * const destination0)
{
    FILE* fSrc;
    FILE* fDest;
    char buffer[512];
    int NbLus;
    char *source, *destination;

    printf("entrance copier_fichier source0=%s  \n",source0);
    printf("entrance copier_fichier destination0=%s  \n",destination0);
    fflush(stdout);
    source = ADAPT_PATH_TO_OS(source0);
    destination = ADAPT_PATH_TO_OS(destination0);
    printf("entrance copier_fichier source=%s  \n",source);
    printf("entrance copier_fichier destination=%s  \n",destination);
    fflush(stdout);
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        printf("cannot open source file=%s@@@ \n",source);
        g_free(source);
        g_free(destination);
        return 1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        printf("cannot open destination file=%s@@@ \n",destination);
        g_free(source);
        g_free(destination);
        fclose(fSrc);
        return 2;
    }
    
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0)
        fwrite(buffer, 1, NbLus, fDest);
    
    g_free(source);
    g_free(destination);
    fclose(fDest);
    fclose(fSrc);
    
    return 0;
}

/*################################################################*/
/*    
 *    This sub will dump a file bite by bite

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
*/
int dump_file(char const * const source)
{
    FILE* fSrc;
//    char c,buffer[512],bfr[3],bfn[3];
    char c,buffer[515];
    int i,NbLus ;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return -1;
    }
    
    NbLus = fread(buffer, 1, 512, fSrc);
        buffer[NbLus] = '\0';
	printf("win_file buffer=%s@@@ \n",buffer);
	   i = 0;
	   for(i = 0 ; i < NbLus ; ++i){
             c = buffer[i] ;
	     printf("dump_file i=%d ic=%d c=%c \n",i,(int) c, c);
	   }//for(i = 0 ; i < NbLus ; ++i)
    fclose(fSrc);
    return 0;
 }
/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    There is no other code-transform of the file.
 *
 *    \r = 13  \n = 10
 *    For unknown reasons, it seems that we have many \r\r\n

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
	  return modif  nombre de modifs dans le fichier
*/
int smpl_win_file(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
//    char c,buffer[512],bfr[3],bfn[3];
    char c,buffer[515],bfr[3],bfn[3];
    int i,i0,ibfn,NbLus,Nb,modif;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
    modif = 0;
    bfr[0]= '\r';
    bfn[0]= '\n';
    ibfn = 0;
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
        buffer[NbLus] = '\0';
	printf("win_file buffer=%s@@@ \n",buffer);
	i0 = 0;
	while(i0 < NbLus){
	   i = i0;
	   while(i < NbLus && (c = buffer[i]) != '\r' && c != '\n')++i;
	   printf("win_file i0=%d i=%d ic=%d \n",i0,i,(int) c);
	   if(ibfn == 1){
              if(buffer[i0] != '\n'){
	         fwrite(bfn, 1, 1, fDest);
		 ++modif;
              }//if(buffer[i0] != '\n'){
	      ibfn = 0;
	   }//if(ibfn == 1){
	   Nb = i -i0 ;
	   if(i >= NbLus){
              fwrite(buffer+i0, 1, Nb, fDest);
	      i0 = NbLus;//this terminates : while(i0 < NbLus){
	      continue;
	   }//if(i >= NbLus){
           fwrite(buffer+i0, 1, Nb, fDest);
	   if(c == '\n'){
	       ++modif;
//??	       fwrite(bfr, 1, 1, fDest);
	       fwrite(bfn, 1, 1, fDest);
	       i0 = i+1;
	       continue;
	   }//if(c = '\n'){
	   //  at that level c = \r
//??	   fwrite(bfr, 1, 1, fDest);
	   ibfn = 1;
	   i0 = i+1;
	   if(i0 < NbLus && buffer[i0] == '\r')++i0;
	}//while(i0 < NbLus){
    }//while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
    
    fclose(fDest);
    fclose(fSrc);
    
    return modif;
}

/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    There is no other code-transform of the file.
 *

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
	  return modif  nombre de modifs dans le fichier
*/
int old_win_file(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char c,buffer[512],bfr[3],bfn[3];
    int i,i0,ibfn,NbLus,Nb,modif;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
    modif = 0;
    bfr[0]= '\r';
    bfn[0]= '\n';
    ibfn = 0;
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
	i0 = 0;
	while(i0 < NbLus){
	   i = i0;
	   while(i < NbLus && (c = buffer[i]) != '\r' && c != '\n')++i;
//	   printf("winfile i0=%d i=%d ic=%d \n",i0,i,(int) c);
	   if(ibfn == 1){
              if(buffer[i0] != '\n'){
	         fwrite(bfn, 1, 1, fDest);
		 ++modif;
              }//if(buffer[i0] != '\n'){
	      ibfn = 0;
	   }//if(ibfn == 1){
	   Nb = i -i0 ;
	   if(i >= NbLus){
              fwrite(buffer+i0, 1, Nb, fDest);
	      i0 = NbLus;//this terminates : while(i0 < NbLus){
	      continue;
	   }//if(i >= NbLus){
           fwrite(buffer+i0, 1, Nb, fDest);
	   if(c == '\n'){
	       ++modif;
	       fwrite(bfr, 1, 1, fDest);
	       fwrite(bfn, 1, 1, fDest);
	       i0 = i+1;
	       continue;
	   }//if(c = '\n'){
	   //  at that level c = \r
	   fwrite(bfr, 1, 1, fDest);
	   ibfn = 1;
	   i0 = i+1;
	}//while(i0 < NbLus){
    }//while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
    
    fclose(fDest);
    fclose(fSrc);
    
    return modif;
}

/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    The input file can be in utf8. It will be transformed
 *    in CP1252  readable by Windows
 *

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
	  return modif  nombre de modifs dans le fichier
*/
int old1_win_file(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char c,buffer[515],bfr[3],bfn[3];
    char ss1[520], *ss;
    int i,i0,ibfn,NbLus,Nb,modif;
    int ok, iso,utf;
    int k,km,ic,iss1 ;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
    modif = 0;
    bfr[0]= '\r';
    bfn[0]= '\n';
    ibfn = 0;
    km = 0;
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
        buffer[NbLus] = '\0';
	printf("win_file buffer=%s@@@ \n",buffer);
	i0 = 0;
/*
 *    we must terminate the preceeding buffer
 */
	if(km > 0){
	printf("win_file km=%d \n",km);
	   ok = 1;
	   while(i0 < NbLus && ok == 1 && k <= km \
	      && (c = buffer[i0]) != '\0' && c != '\r' && c != '\n'){
	      ++i0;
              ic = (int) c; if(ic < 0)ic = ic+256;
	      if(!(ic >= 128 && ic < 192))ok = 0;
	      ss1[iss1]= c;
	      ++iss1;
	      ++k ;
	   }//while(i0 < NbLus && ok == 1 && k <= km 
	   if(k <= km){
	      iso = 1;
	   }else{//if(k <= km){
	      utf = 1;
	   }//if(k <= km){
           if( utf == 1){
              if(iso == 1){
                 ss1[iss1]= '\0';
         printf("win_file 1 bad mixture of iso and utf8 \n ss=%s@@@\n",ss1);
            fflush(stdout);
              }else{//if(iso == 1){
                 ss1[iss1]= '\0';
                 ++modif;
                 ss = g_convert(ss1,-1,"CP1252","UTF-8",NULL,NULL,NULL);
	         if(ss != NULL){
	            strcpy(ss1,ss);
	            g_free(ss);
	         }else{//if(st_line != NULL){
                    printf("error ???? iss1=%d ss1=%s@@@\n",iss1,ss1);
	            strcpy(ss1,"error ???? !!! ");
	         }//if(st_line != NULL){
         printf("win_file  utf8 line \n ss1=%s@@@\n",ss1);
            fflush(stdout);
	         iss1= strlen(ss1);
              }//if(iso == 1){
           }else{//if( utf == 1){
              ss1[iss1]= '\0';
      printf("win_file line \n ss1=%s@@@\n",ss1);
           }//if( utf == 1){
	   fwrite(ss1, 1, iss1, fDest);
	   km = 0;
	   iss1 = 0;
	}//if(km > 0){
/*
 *    End termination of the preceeding buffer
 */
	while(i0 < NbLus){
	   iso = 0;
	   utf = 0;
	   i = i0;
	   while(i < NbLus && (c = buffer[i]) != '\r' && c != '\n'){
	//   printf("win_file i0=%d i=%d ic=%d \n",i0,i,(int) c);
	      iss1 = i-i0;
	      ss1[iss1] = c;
              ic = (int) c; if(ic < 0)ic = ic+256;
              km = 0;
              if(ic >= 192){
                 if( ic < 224){
	            km = 1 ;
                 }else{//if( c < 224){
	            if(ic < 240){
	               km = 2 ;
	            }else{//if(c < 240){
	               if(ic < 248){
	                  km = 3 ;
	               }else{//if(c < 240){
	                  km = 0 ;
		          iso = 1 ;
	               }//if(c < 240){
	            }//if(c < 240){
                 }//if( ic < 224){
              }//if(c >= 192){
	      ++i;
	      ++iss1;
	      if(km > 0){
	     //?a    ++iss1;
	         ok = 1;
		 k = 1;
	         while(i < NbLus && ok == 1 && k <= km \
	            && (c = buffer[i]) != '\0' && c != '\r' && c != '\n'){
	            ++i;
                    ic = (int) c; if(ic < 0)ic = ic+256;
	            if(!(ic >= 128 && ic < 192))ok = 0;
	            ss1[iss1]= c;
	            ++iss1;
	            ++k ;
	         }//while(i0 < NbLus && ok == 1 && k <= km 
	         if(k <= km){
	            if(i < NbLus){
		       k=km+1;//that will terminate the expected char
		       iso = 1;
	            }//if(i < NbLus){
	         }else{//if(k <= km){
	            utf = 1;
	         }//if(k <= km){
	      }//if(km > 0){
	   }//while(i < NbLus && (c = buffer[i]) != '\r'...

	    ss1[iss1]= '\0';
//	   printf("winfile i0=%d i=%d ic=%d \n",i0,i,(int) c);
	   if(ibfn == 1){
              if(buffer[i0] != '\n'){
	         fwrite(bfn, 1, 1, fDest);
		 ++modif;
              }//if(buffer[i0] != '\n'){
	      ibfn = 0;
	   }//if(ibfn == 1){
	   Nb = i -i0 ;
	   if(i >= NbLus){
	      if(km == 0 || k > km){
	         if(utf == 1){
		    if(iso == 1){
            printf("win_file 2 bad mixture of iso and utf in ss1=%s@@@ \n",\
		            ss1);
		    }//if(utf == 1){
                    ++modif;
                    ss = g_convert(ss1,-1,"CP1252","UTF-8",NULL,NULL,NULL);
	            if(ss != NULL){
	               strcpy(ss1,ss);
	               g_free(ss);
	            }//if(st_line != NULL){
	            iss1= strlen(ss1);
	            fwrite(ss1, 1, iss1, fDest);
	         }else{//if(utf == 1){
//    At that level, we should have iso = 1 and utf = 0
                    fwrite(buffer+i0, 1, Nb, fDest);
	         }//if(utf == 1){
	         km = 0;
		 iss1= 0;
		 iso = 0;
		 utf=0;
//?????????????????????????????????????????????????
	      }//if(k > km){
//  at that level we must continue on the next buffer
	      i0 = NbLus;//this terminates : while(i0 < NbLus){
	      continue;
	   }//if(i >= NbLus){
//*******   start writing line 
//At that level, we must write the line, disregarding the values of 
//   k and km
//           fwrite(buffer+i0, 1, Nb, fDest);
		 ss1[iss1] = '\0';
	         if(utf == 1){
		    if(iso == 1){
            printf("win_file 3 bad mixture of iso and utf in ss1=%s@@@ \n",\
		            ss1);
		    }//if(utf == 1){
                    ++modif;
                    ss = g_convert(ss1,-1,"CP1252","UTF-8",NULL,NULL,NULL);
	            if(ss != NULL){
	               strcpy(ss1,ss);
	               g_free(ss);
	            }//if(st_line != NULL){
	            iss1= strlen(ss1);
            printf("win_file 3  ss1=%s@@@ \n",ss1);
	            fwrite(ss1, 1, iss1, fDest);
	         }else{//if(utf == 1){
//    At that level, we should have iso = 1 and utf = 0
                    fwrite(buffer+i0, 1, Nb, fDest);
	         }//if(utf == 1){
	         km = 0;
	         iss1 = 0;
		 iso=0;
		 utf = 0;
//*******   end writing line 
	   if(c == '\n'){
	       ++modif;
    fwrite(bfr, 1, 1, fDest);
	       fwrite(bfn, 1, 1, fDest);
	       i0 = i+1;
	       continue;
	   }//if(c = '\n'){
	   //  at that level c = \r
//??	   fwrite(bfr, 1, 1, fDest);
    fwrite(bfr, 1, 1, fDest);
	   ibfn = 1;
	   i0 = i+1;
	   if(i0 < NbLus && buffer[i0] == '\r')++i0;
	}//while(i0 < NbLus){
    }//while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
    
    fclose(fDest);
    fclose(fSrc);
    
    return modif;
}
/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    The input file can be in utf8. It will be transformed
 *    in CP1252  readable by Windows
 *    In this particular sub, all the difficulty of the problem
 *    has been rejected to aln_getline
 *

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
*/
int win_file(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char *ssd;
    char bfr[3],bfn[3];
    long int ncp,nbytes,nb_lu,ii,l,Nb;
    int i_page ;
    
    
    if ((fSrc = fopen(source, "r")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
/*  bfr[0]= (char) 12 ;
    bfn[0]= (char) 13 ;*/
    bfr[0]= '\r';
    bfn[0]= '\n';
	nbytes = 100;
	ssd = g_malloc((nbytes+5)*sizeof(char));
	i_page = 0;
	ncp=0;
	ii=0;
	while(ii < 100000 && i_page == 0  ){
	   ++ii;
	   nb_lu = aln_getline(&ncp,&ssd,&nbytes,fSrc);
	   if(nb_lu == -2 ){
              i_page = 1;
              continue ;
	   }//if(nb_lu == -2 )
           l = strlen(ssd);
           if(l <= 0){
              l = 1;
              *(ssd) = ' ';
              *(ssd+1) = '\0';
           }//if(l <= 0)
           Nb = l;
           fwrite(ssd, 1, Nb, fDest);
           fwrite(bfr, 1, 1, fDest);
           fwrite(bfn, 1, 1, fDest);
	}//while(ii < 10000 && i_page == 0  )
    g_free(ssd);
    fclose(fDest);
    fclose(fSrc);
    return 0 ;
}
/*################################################################*/
/*    
 *    This sub will test how a file is read by aln_getline 
 *

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
*/
int test_read_file(char const * const source)
{
    FILE* fSrc;
    char *ssd;
    char bfr[3],bfn[3];
    long int ncp,nbytes,nb_lu,ii;
    long int ncpm;
    int i_page ;
    
    
    if ((fSrc = fopen(source, "r")) == NULL)
    {
        return -1;
    }
    
/*  bfr[0]= (char) 12 ;
    bfn[0]= (char) 13 ;*/
    bfr[0]= '\r';
    bfn[0]= '\n';
	nbytes = 100;
	ssd = g_malloc((nbytes+5)*sizeof(char));
	i_page = 0;
	ncp=0;
	ii=0;
	while(ii < 100000 && i_page == 0  ){
	   ++ii;
           ncpm = ncp;
	   nb_lu = aln_getline(&ncp,&ssd,&nbytes,fSrc);
	   if(nb_lu == -2 ){
              i_page = 1;
              continue ;
	   }//if(nb_lu == -2 )
           printf("ncpm=%ld ssd=%s@@@\n",ncpm,ssd);
	}//while(ii < 10000 && i_page == 0  )
    g_free(ssd);
    fclose(fSrc);
    return 0 ;
}
/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    The input file can be in utf8. It will be transformed
 *    in CP1252  readable by Windows
 *    In this particular sub, all the difficulty of the problem
 *    has been rejected to aln_getline
 *    lines such that #  word1    word2 
 *    ar transformed into   #word1 word2
 *

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
*/
int win_file_modif(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char *ssd;
    char bfr[3],bfn[3],c;
    long int ncp,nbytes,nb_lu,ii,l,Nb;
    int i_page,i,j,blanc ;
    
    
    if ((fSrc = fopen(source, "r")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
/*  does not work on linux unknown reason !!!!!
    bfr[0]= (char) 12 ;
    bfn[0]= (char) 13 ;*/
    bfr[0]= '\r' ;
    bfn[0]= '\n' ;
	nbytes = 100;
	ssd = g_malloc((nbytes+5)*sizeof(char));
	i_page = 0;
	ncp=0;
	ii=0;
	while(ii < 100000 && i_page == 0  ){
	   ++ii;
	   nb_lu = aln_getline(&ncp,&ssd,&nbytes,fSrc);
	   if(nb_lu == -2 ){
              i_page = 1;
              continue ;
	   }//if(nb_lu == -2 )
//           DECODE_ACCENTS(ssd);//dangerous if tabs !!
           SECURE_DECODE_ACCENTS(&ssd,&nbytes);
           l = strlen(ssd);
           if(l <= 0){
              l = 1;
              *(ssd) = ' ';
              *(ssd+1) = '\0';
           }else{//if(l <= 0)
              i = 0 ;
              while( i < l && ( c = *(ssd + i)) == ' ')++i;
              if(c == '#'){
                 j = 0;
                 *(ssd+j) = c ;
                 blanc = 1;
                 while(i < l){
                    ++i;
                    c = *(ssd + i);
                    if(c == ' '){
                       ++blanc ;
                    }else{//if(c == ' ')
                       blanc = 0 ;
                    }//if(c == ' ')
                    if(blanc <= 1){
                       ++j ;
                       if(j != i)*(ssd + j) = c ;
                    }//if(blanc <= 1)
                 }//while(i < l)
                 l = j ;
              }//if(c == '#')
           }//if(l <= 0)
           Nb = l ;
           fwrite(ssd, 1, Nb, fDest);
           fwrite(bfr, 1, 1, fDest);
           fwrite(bfn, 1, 1, fDest);
	}//while(ii < 10000 && i_page == 0  )
    g_free(ssd);
    fclose(fDest);
    fclose(fSrc);
    return 0 ;
}

/*################################################################*/
/*
 *   Pour supprimer un fichier
 Sous Windows, à l'aide de DeleteFile (inclure windows.h) 
 et sous UNIX (et plus généralement n'importe quel système se 
 conformant à la norme POSIX), à l'aide de la fonction unlink
 (déclarée dans unistd.h). La bibliothèque standard du C fournit
 également une fonction qui sait remplir cette tâche qui n'est autre 
 que remove (déclarée dans stdio.h).

#include <stdio.h>

int remove(const char * pathname);
*/
/*################################################################*/
char *back_up_file(char *file_path)
/*
 *    input a full path for a file : file_path
 *    examples : /home/toto/file_name   ./file_name    .....
 *    This sub make a copy in :  /home/toto/cpy_file_name
 *                         or :  ./cpy_file_name
 *
 */
 {
    char *ss_cpy,*ss;
    int rtn;
    int l;
       l= strlen(file_path);
       ss_cpy = g_malloc((l+15)*sizeof(char));
//
       ss = PATH_FROM_STRING(file_path);
       strcpy(ss_cpy,ss);
       g_free(ss);
       strcat(ss_cpy,"cpy_");
       ss = FILE_NAME_FROM_STRING(file_path);
       strcat(ss_cpy,ss);
       printf("back_up_file file_path=%s  ss_cpy=%s \n",file_path,ss_cpy);
       fflush(stdout);
       g_free(ss);
       rtn = copier_fichier(file_path,ss_cpy);
       printf("back_up_file rtn=%d \n",rtn);
       fflush(stdout);
//       g_free(ss_cpy);
       if(rtn != 0)ss_cpy = NULL;
       printf("out of back_up_file \n");
       fflush(stdout);
       return(ss_cpy);
 }
/*################################################################*/
char *shape_line_diese(char *line_raw)
/*
 *    input a line like :
 *    #    tin  , turkantin; blabla*KK13-3* R2     plante 
 *    and return a line like :
 *    #tin, turkantin ; blabla *KK13-3 * R2 plante 
 *
 */
 {
    char *ss_cpy, c;
    int i,j,l,lcpy;
    int code_diez,code_start,code_blanc ;
       l= strlen(line_raw);
       if( l > 300)l=300;
       lcpy = l+10;
       ss_cpy = g_malloc((lcpy+5)*sizeof(char));
//
       j = 0 ;
       code_diez = 0 ;
       code_start = 0;
       code_blanc = 0;
       for(i = 0 ; i < l ; ++i){
          if(code_start != 0){
	        *(ss_cpy + j) = '\0' ;
          }//if(code_start != 0){
          c = *(line_raw + i);
	  switch (c) {
	     case '#':
//	        printf("enter case diese \n");
	        if(code_start != 0 && code_blanc == 0 && \
		*(ss_cpy + j-1) != '#'){
	           *(ss_cpy + j) = ' ' ;
		   ++j;
	        }//if(code_start != 0 && code_blanc == 0){
	        *(ss_cpy + j) = c ;
	        code_diez = 1 ;
		code_blanc = 0 ;
		code_start = 1;
	     break;
	     case ' ': //dieze is not followed by blancs
//	        printf("enter case blanc \n");
	        if(code_diez != 1 && code_start != 0 && code_blanc == 0){
	           *(ss_cpy + j) = c ;
		   ++code_blanc ;
	        }else{//if(code_diez != 1){
		   --j;
	        }//if(code_diez != 1){
	     break;
	     case ',':// no blanc before, one after

	        *(ss_cpy + j) = '\0' ;
//	        printf("enter case virg j=%d ss_cpy=%s@@@ \n",j,ss_cpy);
	        if(code_blanc != 0){
		   --j ;
		   while(j >= 0 && *(ss_cpy + j) == ' ' )--j;
		   ++j;
	        }//if(code_blanc != 0){
	        *(ss_cpy + j) = c ;
		code_start = 1;
		++j;
	        *(ss_cpy + j) = '\0' ;
//	        printf("after case virg j=%d ss_cpy=%s@@@ \n",j,ss_cpy);
	        *(ss_cpy + j) = ' ' ;
		code_blanc = 1;
	        code_diez = 0 ;
/*		++j;
	        *(ss_cpy + j) = '\0' ;
                printf(" 1ss_cpy=%s@@@ \n\n",ss_cpy);
		fflush(stdout);
		--j;*/
	     break;
	     case ';':// one blanc before, one after
//	        printf("enter case point virg \n");
	        if(code_blanc == 0){
	           *(ss_cpy + j) = ' ' ;
		   ++j;
	        }//if(code_blanc == 0){
	        *(ss_cpy + j) = c ;
		++j;
	        *(ss_cpy + j) = ' ' ;
		code_blanc = 1;
		code_start = 1;
	        code_diez = 0 ;
	     break;
	     case '*':// one blanc before
//	        printf("enter case star \n");
	        if(code_blanc == 0){
	           *(ss_cpy + j) = ' ' ;
		   ++j;
	        }//if(code_blanc == 0){
	        *(ss_cpy + j) = c ;
		code_blanc = 0;
		code_start = 1;
	        code_diez = 0 ;
	     break;
	     default :
//	        printf("enter case default \n");
	        *(ss_cpy + j) = c ;
		code_start = 1;
		code_blanc = 0;
	        code_diez = 0 ;
	     break;
	  }// end of switch 
          if(j >= lcpy){
	     lcpy = j + 10 ;
             ss_cpy = g_realloc(ss_cpy,(lcpy+5)*sizeof(char));
          }//if(j >= lcpy){
	  ++j;
       }//for(i = 0 ; i < l ; ++i){
       *(ss_cpy + j) = '\0' ;
       RM_EXTRA_BLANCS(ss_cpy);
/*     printf("line_raw=%s@@@ \n",line_raw);
       printf("  ss_cpy=%s@@@ \n\n",ss_cpy);
       fflush(stdout);*/
       return(ss_cpy);
 }
/*################################################################*/
void   CREATE_DIR_IF(FILE *fp_log,char *spath_cp)
/*
*    Create a directory whose path is spath_cp if this
*    directory does not exist
*    spath_cp is copied and transformed into spath_cpy
*    Blancs are removed in spath_cpy as well as multi /// or multi \\\
*    we may have to create more than one directory if we have
*    something like  ./AAA/ BBB/  CCC
*    which is first translated into : ./AAA/BBB/CCC
*    and all the necessary directories are created
*/
{
DIR   *dip;
int i,islash,iloop,j,lsc ;
char c, *spath_cpy ;
/*   printf("\n Entering CREATE_DIR_IF spath_dir=%s@@@@ \n",spath_cpy);
   fprintf(fp_log,"\n Entering CREATE_DIR_IF spath_dir=%s@@@@ \n",spath_cpy);
           fflush(stdout); */
   lsc = strlen(spath_cp);
   spath_cpy = g_malloc((lsc+5)*sizeof(char));
   strcpy(spath_cpy,spath_cp);
   RM_ALL_BLANCS(spath_cpy);
   lsc = strlen(spath_cpy);
   i = 0 ;
   j = 0 ;
   islash = 0 ;
   for(i = 0 ; i < lsc ; ++i){
      if(islash > 0 ){
         if(( c = *(spath_cpy+i) ) == '/' || c  == '\\'  ){
            continue;
         }else{//if((*(spath_cpy+i) == '/' || *(spath_cpy+i) == '\\'  ))
            islash = 0 ;
            if(j != i )*(spath_cpy+j) = *(spath_cpy+i) ;
            ++j;
            continue;
         }//if((*(spath_cpy+i) == '/' || *(spath_cpy+i) == '\\'  ))
      }//if(islash > 0 )
      if(j != i )*(spath_cpy+j) = *(spath_cpy+i) ;
      ++j;
      if(( c = *(spath_cpy+i) ) == '/' || c  == '\\'  )islash = 1 ;
   }//for(i = 0 ; i < lsc ; ++i)
   c = *(spath_cpy+j - 1);
   if(c == '/' || c == '\\')--j;
   *(spath_cpy+j) = '\0';
   lsc = j ;
   if(lsc <= 0){
      g_free(spath_cpy);
      return;
   }//if(lsc <= 0)
/*	   printf("\n Entering CREATE_DIR_IF spath_dir=%s@@@@ \n",spath_cpy);
           fflush(stdout); */
   iloop = 1;
   i = 0 ;
   while(i < lsc && iloop == 1){
      while(i < lsc && ( *(spath_cpy+i) != '/' || *(spath_cpy+i) != '\\' ) )++i;
/*	   printf(" loop level 0 CREATE_DIR_IF i=%d lsc=%d spath_dir=%s@@@ \n",i,lsc,spath_cpy);
           fflush(stdout);*/ 
      if(i == lsc)iloop = 0 ;
      c = *(spath_cpy+i);
      *(spath_cpy+i) = '\0';
/*	   printf(" loop level 1 CREATE_DIR_IF i=%d spath_dir=%s@@@ \n",i,spath_cpy);
           fflush(stdout); */
/*      if(i == 1 &&  *(spath_cpy) == '.' ){
        *(spath_cpy+i) = c ;
        ++i;
        continue ;
      }//if(i == 2 &&  *(spath_cpy) == '.' )*/
        if((dip = opendir(spath_cpy)) == NULL){
	   printf("\n Creating directory=%s@@@ \n",spath_cpy);
	   fprintf(fp_log,"\n Creating directory=%s@@@ \n",spath_cpy);
           fflush(stdout); fflush(fp_log);

#if WINDOWS
char *s_win;
int i,l,lwin;
           l = strlen(spath_cpy);
           lwin = l + 6 ;
	   s_win = g_malloc((lwin+5)*sizeof(char));
           strcpy(s_win,"mkdir ");
	   strcat(s_win,spath_cpy);
	   for(i= 0 ; i < lwin ; ++i){
	      if(*(s_win+i) == '/')*(s_win+i) = '\\'	   ;
	   }//for(i= 0 ; i < l ; ++i)
	   printf("\n Windows : Creating directory %s \n",s_win);
	   fprintf(fp_log,"\n Windows : Creating directory %s \n",s_win);
	   system(s_win);
	   g_free(s_win);
#endif
#if LINUX
	   mkdir(spath_cpy ,0777);
#endif
        }else{//if((dip = opendir(spath_cpy)) == NULL){
	   printf("\n Existing directory %s \n",spath_cpy);
//	   fprintf(fp_log,"\n Existing directory %s \n",spath_cpy);
           fflush(stdout); 
//           fflush(fp_log);
        }//if((dip = opendir(spath_cpy)) == NULL){
        *(spath_cpy+i) = c ;
        ++i;
   }//while(iloop == 1){
   g_free(spath_cpy);
}
/*################################################################*/
char *ADAPT_PATH_TO_OS(char const * const spath0)
/*
*    This sub will replace / by \ in WINDOWS
*             will replace \ by / in LINUX
*/
{
int i,l;
char *spath;
    l = strlen(spath0);
    spath = g_malloc((l+5)*sizeof(char));
    if(l == 0){
       *spath = '\0';
       return (spath);
    }//if(l == 0)
    strcpy(spath,spath0);
    if(STR_STR_DEB1(spath,"/home/") ){
       printf("ADAPT_PATH_TO_OS spath=%s@@@ \n",spath);
       return (spath);
    }//if(strstr() != NULL)

    for(i = 0 ; i <= l ; ++i){
       *(spath+i) = *(spath0+i);
       if(WINDOWS == 1){
          if(*(spath+i) == '/')*(spath+i) = '\\';
          continue;
       }//if(WINDOWS == 1)
       if(LINUX == 1){
          if(*(spath+i) == '\\')*(spath+i) = '/';
          continue;
       }//if(WINDOWS == 1)
    }//for(i = 0 ; i <= l ; ++l)
    printf("ADAPT_PATH_TO_OS spath=%s@@@ \n",spath);
    return (spath);
}
/*################################################################*/
int STR_STR_END0(char *ss, char *ss_prob)
/*
*    This sub will test string ss to know if it is ending
*    by all the characters of string ss_prob
*    strict, first blancs are taken into account (in ss_prob)
*    trailing blancs are ignored in ss and ss_prob
*    return 1 if ending math ok  , returns 0 otherwise
*/
{
int test, lss,lprob ;
int i;
   lss = strlen(ss)-1;
   lprob = strlen(ss_prob)-1;
   while(lss >= 0 && *(ss+lss) == ' ')--lss;
   while(lprob >= 0 && *(ss_prob + lprob) == ' ')--lprob;
   if(lss < 0){
      if(lprob < 0){
         test = 1 ;
         return (test);
      }else{//if(lprob < 0)
         test = 0 ;
         return (test);
      }//if(lprob < 0)
   }//if(lss < 0)
   if(lprob < 0){
      test = 1 ;
      return (test);
   }//if(lprob < 0)
   if(lprob > lss){
      test = 0 ;
      return (test);
   }//if(lprob > lss)
/*
*/
   test = 1;
   i = 0 ;
   while( test == 1 && i <= lprob){
      if( *(ss_prob + lprob - i) != *(ss + lss -i) ) test = 0;
      ++i ;
   }//while( test == 1 && i < lprob)
   return (test);

}
/*################################################################*/
int STR_STR_DEB0(char *ss, char *ss_prob)
/*
*    This sub will test string ss to know if it is beginning
*    by all the characters of string ss_prob
*    strict, first blancs are taken into account (ss AND ss_prob) 
*/
{
int test, lss,lprob ;
int i;
   lss = strlen(ss);
   lprob = strlen(ss_prob);
   if(lss == 0){
      if(lprob == 0){
         test = 1 ;
         return (test);
      }else{//if(lprob == 0)
         test = 0 ;
         return (test);
      }//if(lprob == 0)
   }//if(lss == 0)
   if(lprob == 0){
      test = 1 ;
      return (test);
   }//if(lprob == 0)
   if(lprob > lss){
      test = 0 ;
      return (test);
   }//if(lprob > lss)
/*
*/
   test = 1;
   i = 0 ;
   while( test == 1 && i < lprob){
      if( *(ss_prob + i) != *(ss + i) ) test = 0;
      ++i ;
   }//while( test == 1 && i < lprob)
   return (test);
}
/*################################################################*/
int STR_STR_DEB1(char *ss, char *ss_prob)
/*
*    This sub will test string ss to know if it is beginning
*    by all the characters of string ss_prob
*    relax, first blancs  not taken into account (for ss AND ss_prob)
*    however, trailing blancs are taken into account
*/
{
int test, lss,lprob ;
int i,j,iss0,iprob0 ;
   lss = strlen(ss);
   lprob = strlen(ss_prob);
   if(lss == 0){
      if(lprob == 0){
         test = 1 ;
         return (test);
      }else{//if(lprob == 0)
         test = 0 ;
         return (test);
      }//if(lprob == 0)
   }//if(lss == 0)
   if(lprob == 0){
      test = 1 ;
      return (test);
   }//if(lprob > lss)
/*
*/
   iss0 = 0 ;
   while(iss0 < lss && *(ss + iss0) == ' ')++iss0 ;
   iprob0 = 0 ;
   while(iprob0 < lprob && *(ss_prob + iprob0) == ' ')++iprob0 ;
/*
*/
   if(lss-iss0 == 0){
      if(lprob-iprob0 == 0){
         test = 1 ;
         return (test);
      }else{//if(lprob == 0)
         test = 0 ;
         return (test);
      }//if(lprob == 0)
   }//if(lss == 0)
   if(lprob-iprob0 == 0){
      test = 1 ;
      return (test);
   }//if(lprob > lss)
/*
*/
   if(lprob-iprob0 > lss - iss0){
      test = 0 ;
      return (test);
   }//if(lprob > lss)
/*
*/
   test = 1;
   i = iprob0 ;
   j = iss0 ;
   while( test == 1 && i < lprob){
      if( *(ss_prob + i) != *(ss + j) ) test = 0;
      ++i ;
      ++j ;
   }//while( test == 1 && i < lprob)
   return (test);
}

/*################################################################*/
int UNIK_DIESE_IN_FILE(FILE *fp,char *ss_prob)
/*
 *    We look if ss_prob was not already written in file fp
 *    However lessons may have been modified and agreement 
 *    must be limited to the entry and lesson name
 *    ##annezad *K9 * personne société  
 *    #gloestr *KK19-1 5129 * Q2 ustensile maison  
 *    ##glaz #glaz, glizi *KK20-3 5327 * maladie 
 *    must be limited to :
 *    #annezad *K9   
 *    #gloestr *KK19-1   
 *    #glaz, glizi *KK20-3 
 *    after we have tested all the preceeding entries, 
 *    looking if no line contains the limited ss_prob,
 *    we reposition ourself to the end of the fp_gene file
 *    OUTPUT :
 *       unik = 1   if no other line in file
 *       unik = 0   if already one line
 *       unik = -1  bad utilisation of UNIK_DIESE_IN_FILE
 */
{//==========Start of UNIK_DIESE_IN_FILE ==============================
int unik ;
int i,i0,i1,iloop,lss;
long int nb_lu,nc,nbytes ;
char *ssd,c;
//   printf("enter UNIK_DIESE_IN_FILE  ss_prob=%s \n",ss_prob);
   unik = 0;
   if(*ss_prob != '#'){
      unik = -1 ;
      return unik;
   }//if(jcont == 0){
/*
 *   Preparation of string ss_prob
 */
   lss = strlen(ss_prob);
   i = 0 ;
   i0= 0;
   iloop = 1 ;
   while(i < lss && iloop == 1){
      c= *(ss_prob+i);
      if(c == '#')i0 = i;//so i0 is the last #
      if(c == '*')iloop = 0;
      ++i;
   }//while(i < lss && iloop == 1)
   i1 = i;
   c = '\0'; //may be used later
   if(iloop == 0){
      while(i < lss && *(ss_prob+i) != ' ')++i;
      c = *(ss_prob+i);
      i1 = i;
      *(ss_prob+i) = '\0';
   }//if(iloop == 0){
//   printf("UNIK_DIESE_IN_FILE  prepared ss_prob+i0=%s \n",ss_prob+i0);
/*
 *   End preparation of string ss_prob
 */
   nbytes = 100;
   ssd = g_malloc((nbytes+5)*sizeof(char));
   i = 1;
   iloop = 1 ;
//   fseek(fp_gene,0,SEEK_SET);
   fflush(fp);
   unik = 1 ;
   nc = 0 ;
   while( i <= 10000 && iloop > 0){
      nb_lu = aln_getline(&nc,&ssd,&nbytes,fp);
//      printf("UNIK_DIESE_IN_FILE  i=%d  nb_lu=%ld ssd=%s \n",i,nb_lu,ssd);
      if(nb_lu == -2 || strstr(ssd,"END_OF_FILE") != NULL ){
         iloop = 0 ;
      }/*if(nb_lu == -2){*/
      if(*ssd != '#')continue;
      if(strstr(ssd,ss_prob+i0) != NULL){
         iloop = 0 ;
         unik = 0 ;
      }//if(strstr(ssd,ss) != NULL)
      ++i;
   }//while( i <= jcont && iloop > 0)
/*
 *   Now we must go to end of file fp
 */
   fseek(fp,0,SEEK_END);
   *(ss_prob+ i1) = c ;
   g_free(ssd);
   return unik;
}//==========End of UNIK_DIESE_IN_FILE ==============================
/*################################################################*/
void ADD_LINE_TO_STRING(char **ss,char *s_added)
/*
 *   This will add \ns_added to ss
 *   and adjust the size of ss
 */
{//==========Start of ADD_LINE_TO_STRING ==============================
int l1,l2,lt;
   l1 = strlen(*ss);
   l2 = strlen(s_added);
   lt = l1 + l2 + 1;
   *ss = g_realloc(*ss,(lt+5)*sizeof(char));
   strcat(*ss,"\n");
   strcat(*ss,s_added);
}//==========End of ADD_LINE_TO_STRING ==============================
/*################################################################*/
void ADD_STRING_TO_STRING(char **ss,char *s_added)
/*
 *   This will add blanc s_added to ss
 *   and adjust the size of ss
 *   so the 2 strings are separated by a space character
 */
{//==========Start of ADD_LINE_TO_STRING ==============================
int l1,l2,lt;
   l1 = strlen(*ss);
   l2 = strlen(s_added);
   lt = l1 + l2 + 1;
   *ss = g_realloc(*ss,(lt+5)*sizeof(char));
   strcat(*ss," ");
   strcat(*ss,s_added);
}//==========End of ADD_STRING_TO_STRING ==============================
/***********************************************************************/
int  REL_PATH_IF(char **stpath_lesson,char *spath_of_conf)
/*
 *  On imput, we have two absolute path
 *  On output, we have extracted spath_of_conf from  stpath_lesson
 *  if that is possible
 *  The returned value is :
 *             1  if all ok, stpath_lesson beginning by  spath_of_conf
 *                then  spath_of_conf is removed from stpath_lesson
 *             0  if stpath_lesson already relative path 
 *            -1  if only partial match 
 *            -2  if spath_of_conf is relative path 
 *            -3  if strlen(*stpath_lesson) <= 0
 *            -4  if strlen(spath_of_conf) <= 0
 */
{/*====================    end   of REL_PATH_IF    =======================*/
int l0,l1,i;
char c;
   RM_ALL_BLANCS(*stpath_lesson);
   RM_ALL_BLANCS(spath_of_conf);
/*   printf("enter REL_PATH_IF *stpath_lesson=%s@@@@ \n",*stpath_lesson);
   printf("enter REL_PATH_IF spath_of_conf=%s@@@@ \n",spath_of_conf);*/
   if(*spath_of_conf == '.')return(-2);
   if(**stpath_lesson == '.')return(0);
   l1 = strlen(*stpath_lesson);
   if(l1 <= 0)return(-3);
/*   c = *(*stpath_lesson + l1-1);
   if(c == '/' || c == '\\'){
      --l1;
      *(*stpath_lesson + l1) = '\0';
   }//if(c == '/' || c == '\\')*/
   l0 = strlen(spath_of_conf);
   if(l0 <= 0)return(-3);
   c = *(spath_of_conf + l0 -1);
   if(c == '/' || c == '\\'){
      --l0;
      *(spath_of_conf + l0) = '\0';
   }//if(c == '/' || c == '\\')
   if(l0 > l1)return(-1);
   i = 0 ;
   while(i < l0 && *(spath_of_conf + i) == *(*stpath_lesson + i)) ++i ;
//   printf("REL_PATH_IF l0= %d i= %d \n",l0,i);
   if(i < l0)return(-1);//partial or no match
   if((c = *(*stpath_lesson + l0 ) ) != '/' && c !=  '\\' )return(-1);
   *(*stpath_lesson + l0 -1) = '.';
   for(i = 0 ; i < l0 -1 ; ++i ) *(*stpath_lesson + i) = ' ';
   RM_ALL_BLANCS(*stpath_lesson);
   return(1);
}/*====================    end   of REL_PATH_IF    =======================*/
/*################################################################*/
long int POS_TO_END_OF_FILE(FILE *fp_rec)
/*
 *  This sub will close the diaoulek record files 
 *  which are used to record the history of the responses
 *  in order to make statistics that may be used to compute
 *  the probability that a word is unknown
 */
{//=================  start of POS_TO_END_OF_FILE  =================  
//char *sprov;
long int nc ;
char *ssd;
int ii,i_page;
long int ncp,ncpm,nbytes,nb_lu;

       nc = ftell(fp_rec);
/*
 *   We may have errors when we are using Wine and simulating
 *   a windows system so we recompute a new value of nc
 *   by reading lines. Because nc seems always inferior or equal
 *   to its true value
 */
	ncp=nc;
	ii=0;
        i_page = 0 ;
	nbytes = 100;
	ssd = g_malloc((nbytes+5)*sizeof(char));
	while(ii < 100000 && i_page == 0  ){
	   ++ii;
           ncpm = ncp;
	   nb_lu = aln_getline(&ncp,&ssd,&nbytes,fp_rec);
	   if(nb_lu == -2 || strstr(ssd,"END_OF_FILE") != NULL  ){
              i_page = 1;
              continue ;
	   }//if(nb_lu == -2 )
//           printf("ncpm=%ld ssd=%s@@@\n",ncpm,ssd);
        }//while(ii < 10000 && i_page == 0  )
        g_free(ssd);
        nc = ncpm ;
        fseek(fp_rec,ncpm,0);  //positioning at end of file
   return(nc);
}//=================  end   of POS_TO_END_OF_FILE  =================
