# include <stddef.h>
# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
#include <time.h>
#include <dirent.h>
#include <gtk/gtk.h>
#include "diaou_0.h"

  #include <sys/stat.h>
  #include <sys/types.h>
//  #include <sys/dir.h>


/*################################################################*/
/*
 *   Tis file is devoted to the computation of 
 *   the statistics into the LOG directory
 */
/*################################################################*/
FILE *OPEN_DIAOU_REC( FILE *fp_log , int code, char *spath_idx1)
/*
 *  This sub will open the diaoulek record files 
 *  which are used to record the history of the responses
 *  in order to make statistics that may be used to compute
 *  the probability that a word is unknown
 *  if code = 1  opens file diaou_rec_qr
 *  if code = 2  opens file diaou_rec_rq
 */
{//=================  start of OPEN_DIAOU_REC  =================  
DIR   *dip;
char  *spath, *spath_log,*ssnb ;
//char *sprov;
int i,j,lsp;
char *ssd, *ss = NULL;
struct stat *stat_file ;
FILE *fp_rec = NULL ;
long int nc,ncp,nb_lu,nbytes,i_extracted[12] ;
int lssnb ;

   if(code < 1 ||  code > 2){
      fprintf(fp_log,"OPEN_DIAOU_REC error code=%d should be 1 or 2 \n",code);
      exit(1);
   }//if(code < 1 ||  code > 2){
      ss = g_get_current_dir();
      printf("OPEN_DIAOU_REC current_dir=%s@@@ \n",ss);
      fprintf(fp_log,"OPEN_DIAOU_REC current_dir=%s@@@ \n",ss);
      g_free(ss); ss = NULL;
   fflush(stdout);
   fflush(fp_log);
   spath = spath_idx1 ;
   lsp = strlen(spath) + 20;
   spath_log = g_malloc((lsp+5)*sizeof(char));
//   strcpy(spath_log,"      ");
   strcpy(spath_log,spath);
   i= strlen(spath_log)-4;
   *(spath_log + i ) = '\0';
   strcat(spath_log ,"LOG");
        if((dip = opendir(spath_log)) == NULL){
	   printf("\n Create directory %s \n",spath_log);
	   fprintf(fp_log,"\n Create directory %s \n",spath_log);

#if WINDOWS
char *s_win;
int l,lwin;
           l = strlen(spath_log);
           lwin = l + 6 ;
	   s_win = g_malloc((lwin+5)*sizeof(char));
           strcpy(s_win,"mkdir ");
	   strcat(s_win,spath_log);
	   for(i= 0 ; i < lwin ; ++i){
	      if(*(s_win+i) == '/')*(s_win+i) = '\\'	   ;
	   }//for(i= 0 ; i < l ; ++i){
	   printf("\n Windows : Create directory %s \n",s_win);
	   fprintf(fp_log,"\n Windows : Create directory %s \n",s_win);
	   system(s_win);
	   g_free(s_win);
#endif
#if LINUX
	   mkdir(spath_log ,0777);
#endif
        }//if((dip = opendir(spathlog) == NULL)
/*
 */
       if(code == 1){
          strcat(spath_log,"/diaou_rec_qr");
       }else{//if(code == 1){
          strcat(spath_log,"/diaou_rec_rq");
       }//if(code == 1){
      printf("OPEN_DIAOU_REC spath_log=%s@@@ \n",spath_log);
      fflush(stdout);
       stat_file = g_malloc(sizeof(struct stat));
       i = stat(spath_log,stat_file);
       lssnb = 20;
       ssnb= g_malloc((lssnb+5)*sizeof(char));
	nbytes = 100;
	ssd = g_malloc((nbytes+5)*sizeof(char));
       if( i < 0){
          printf("file %s  does not exist create \n",spath_log);
          fprintf(fp_log,"file %s  does not exist create \n",spath_log);
          fflush(stdout);
          /*
           *  We must do there a ccdb  check and correct data base
           *  because, most probably, we are changing of program version
           */
           
           /*============*/
          fp_rec = fopen(spath_log,"w+");
          nc = 13;
          LNB_12CHAR(nc,ssnb);
//	  strncat(ssd, ssnb,12);
          fprintf(fp_rec,"%s\n",ssnb);
/*          printf("level 2 create file %s ssnb=%s@@@@\n",spath_log,ssnb);
          fflush(stdout);*/
          CLOSE_DIAOU_REC(fp_rec);
       }/* if(stat_file != NULL){*/
          fp_rec = fopen(spath_log,"r+");
          ncp = 0 ;
	  nb_lu = aln_getline(&ncp,&ssd,&nbytes,fp_rec);
          printf("sub OPEN_DIAOU_REC file read ssd=%s@@@ \n",ssd);
          j =  EXTR_N_LINT(1,ssd, i_extracted);
          if(i_extracted[0] != 1){
             printf("sub OPEN_DIAOU_REC error 1 EXTR_N_LINT \n");
             printf("ssd=%s@@@@ \n",ssd);
             fprintf(fp_log,"sub OPEN_DIAOU_REC error 1 EXTR_N_LINT \n");
             fprintf(fp_log,"ssd=%s@@@@ \n",ssd);
             exit(1);
          }//if(j != 1){
          nc = i_extracted[1];
          fseek(fp_rec,nc,0);
//          printf("sub OPEN_DIAOU_REC positioning in file at nc=%ld \n",nc);
//       }/* if(stat_file != NULL){*/
   g_free(ssnb);
   g_free(ssd);
   g_free(spath_log);
   return(fp_rec);
}//=================  end   of OPEN_DIAOU_REC  =================  
/*################################################################*/
void CLOSE_DIAOU_REC(FILE *fp_rec)
/*
 *  This sub will close the diaoulek record files 
 *  which are used to record the history of the responses
 *  in order to make statistics that may be used to compute
 *  the probability that a word is unknown
 */
{//=================  start of CLOSE_DIAOU_REC  =================  
char  *ssnb ;
//char *sprov;
long int nc ;
int lssnb ;
char *ssd;
int ii,i_page;
long int ncp,ncpm,nbytes,nb_lu;

       lssnb = 20;
       ssnb= g_malloc((lssnb+5)*sizeof(char));
          nc = ftell(fp_rec);
/*
 *   We may have errors when we are using Wine and simulating
 *   a windows system so we recompute a new value of nc
 *   by reading lines. Because nc seems always inferior or equal
 *   to its true value
 */
	ncp=nc;
	ii=0;
        i_page = 0 ;
	nbytes = 100;
	ssd = g_malloc((nbytes+5)*sizeof(char));
	while(ii < 100000 && i_page == 0  ){
	   ++ii;
           ncpm = ncp;
	   nb_lu = aln_getline(&ncp,&ssd,&nbytes,fp_rec);
	   if(nb_lu == -2 ){
              i_page = 1;
              continue ;
	   }//if(nb_lu == -2 )
//           printf("ncpm=%ld ssd=%s@@@\n",ncpm,ssd);
        }//while(ii < 10000 && i_page == 0  )
        g_free(ssd);
          nc = ncpm ;
          LNB_12CHAR(nc,ssnb);
/*      printf("CLOSE_DIAOU_REC ssnb=%s@@@ \n",ssnb);
      fflush(stdout);*/
          fseek(fp_rec,0,0);
          fprintf(fp_rec,"%s",ssnb);
   fclose(fp_rec);
   g_free(ssnb);
   return;
}//=================  end   of CLOSE_DIAOU_REC  =================  
/*################################################################*/
