# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
# include <stddef.h>
#include <gtk/gtk.h>
#include <dirent.h>
#include "diaou_0.h"
/********************************************************************/
/********************************************************************/
/********************************************************************/
/************          diaou_6.c                         ************/
/************   This file contains the subs              ************/
/************   which are used to import  a        .     ************/
/************   configuration file : diaou.conf          ************/
/************                                            ************/
/********************************************************************/
/********************************************************************/
static void      EIL_FURCH_SET(FILE *fp_log,FILE *fp,char *s_shift,\
           Trf_string *G_dico);
static void JUMP(FILE *fp);
static void  IMPORT_SND_FILE(FILE *fp_log,char *s_sndfile,\
    char *stpath_lesson,char *stpath_dup, char *s_dirconf, char *ss_curdir,\
       int relativ,char *s_found);
/********************************************************************/

void IMPORT( char *ss,Trf_book *book)
/*
 *   Import the IDX1 and the lessons from a conf file
 *   We copy the imported IDX1 into our own IDX1
 *   We copy also the lessons and assiosiated audio files.
 *   They will hopefully in a place similar to the original
 *   otherwise they will be in a FOUND directory.
 *   However the lessons which already exist
 *   are skipped.
 *
 */
{/*====================    start of IMPORT    =======================*/
FILE *fp_log , *fp;
int i,j,l,ll,l1,lst,i_idx1;
char *spath_of_conf,*s_dirconf,*s_alias,*ss_alias ;
char *stpath_lesson, *s_lesson, *stpath_dup ;
char *path_dirless, *s_dirless, *ss_curdir ;
char *ss_sndfile,*s_sndfile,*spath_idx1_ori,*spath_idx1_cpy ;
char *spath_idx0_cpy,*scpy ;
char *s_idx1_ori,*s_idx1_cpy,*s_idx1_cp0,*spath_found_cpy;
Trf_string *G_dico ;
int nb_lesson,iless,nb_sndfile,num,lcpy ;
int  l_idx1_ori,l_idx1_cpy ;
int relativ,iscpy,isndwav;
DIR   *dip;
GtkWidget *Info;
char *ss1,word_internat[20] ;
    ss_curdir = g_get_current_dir();
    G_dico = g_malloc(sizeof(Trf_string));
    printf("sub IMPORT ss=%s \n",ss);
    fp_log = book->fp_log ;
    fprintf(fp_log,"sub IMPORT ss=%s \n",ss);
    l =strlen(ss);
    i = l-1;
    while(i >= 0 && *(ss+i) == ' ' )--i ;
    l = i+1;
    *(ss+l) = '\0' ;
    i = 0;
    while(i < l && *(ss+i) == ' ' )++i ;
    if(i >= l){
       printf("sub IMPORT no import return \n");
       fprintf(fp_log,"sub IMPORT no import return \n");
       strcpy(word_internat,"#on_warning-2");
       ss1 = RECUP_INTERNAT_WORD( book->fp_log, word_internat,\
         1,book -> G_internat);
       ON_WARNING(book,ss1);
       g_free(ss1);
       g_free(G_dico);
       g_free(ss_curdir);
       return ;
    }//if(i >= l){
     fp = fopen(ss+i,"r");
     if(fp == NULL){
        printf("IMPORT return cannot open file=%s@@@@ \n",ss);
        fprintf(fp_log,"IMPORT return cannot open file=%s \n",ss);
	fflush(stdout);
        strcpy(word_internat,"#on_warning-3");
        ss1 = RECUP_INTERNAT_WORD( book->fp_log, word_internat,\
             1,book -> G_internat);
        ADD_LINE_TO_STRING(&ss1,ss);
        ON_WARNING(book,ss1);
	fflush(fp_log);
        g_free(G_dico);
        g_free(ss_curdir);
	return;
     }
     spath_of_conf = PATH_FROM_STRING(ss+i);
    if(*(spath_of_conf) == '.'){
        printf("IMPORT return cannot import from a relative path=%s \n",spath_of_conf);
        fprintf(fp_log,"IMPORT return cannot import from a relative path=%s \n",spath_of_conf);
        strcpy(word_internat,"#on_warning-4");
        ss1 = RECUP_INTERNAT_WORD( book->fp_log, word_internat,\
             1,book -> G_internat);
        ADD_LINE_TO_STRING(&ss1,ss);
        ON_WARNING(book,ss1);
        g_free(spath_of_conf);
        g_free(G_dico);
        g_free(ss_curdir);
        return;
    }//if(*(spath_of_conf) == '.'){

    EIL_FURCH_SET(fp_log,fp,spath_of_conf,G_dico);
    MAKE_ST_ALIAS(fp_log,G_dico); 
    printf("st_alias=%s \n",G_dico -> st_alias);
    fflush(stdout);
    printf("spath_idx1=%s \n",G_dico -> spath_idx1);
    fflush(stdout);

/*    printf("st_idx1=%s \n",G_dico -> st_idx1);
    fflush(stdout); plante, non definie */
    fclose(fp);
       j = strlen(spath_of_conf)-1 ;
       while(j >= 0 && *(spath_of_conf+j) == ' ')--j;
       if( *(spath_of_conf+j) == '/' || *(spath_of_conf+j) == '\\' )\
                       *(spath_of_conf+j) = ' ';
       s_dirconf = FILENAME_FROM_PATH( spath_of_conf);
       RM_ALL_BLANCS(s_dirconf);
/*
 * Definition of the spath_idx1_ori and the spath_idx1_cpy
 *  We copy the imported IDX1 (spath_idx1_ori) into our
 *  own IDX1 (spath_idx1_cpy)
 */
    if(*(G_dico -> spath_idx1) == '.' &&\
   ( *(G_dico -> spath_idx1 +1) == '/' || *(G_dico -> spath_idx1 +1 ) == '\\'  ) ){
       l1 = strlen(spath_of_conf) + strlen(G_dico -> spath_idx1) ;
       spath_idx1_ori = g_malloc((l1+5)*sizeof(char));
       strcpy(spath_idx1_ori,spath_of_conf);
       strcat(spath_idx1_ori,G_dico -> spath_idx1 + 1);
       i_idx1 = 1 ;
       if((dip = opendir(spath_idx1_ori)) == NULL)i_idx1 = 0 ;
    }else{//if(*(G_dico -> spath_idx1) == '.' &&
       l1 =  strlen(G_dico -> spath_idx1) ;
       spath_idx1_ori = g_malloc((l1+5)*sizeof(char));
       strcat(spath_idx1_ori,G_dico -> spath_idx1 );
       i_idx1 = 1 ;
       if((dip = opendir(spath_idx1_ori)) == NULL)i_idx1 = 0 ;
    }//if(*(G_dico -> spath_idx1) == '.' &&
/*
 *  We copy the imported IDX1 into our own IDX1
 */
    if(i_idx1 == 1){
       if(*(book -> G_kentel -> spath_idx1) == '.' &&\
      ( *(book -> G_kentel -> spath_idx1 +1) == '/' || *(book -> G_kentel -> spath_idx1 +1 ) == '\\'  ) ){
          l1 = strlen(ss_curdir) + strlen(book -> G_kentel -> spath_idx1) ;
          spath_idx1_cpy = g_malloc((l1+5)*sizeof(char));
          spath_found_cpy = g_malloc((l1+6)*sizeof(char));
          spath_idx0_cpy = g_malloc((l1+5)*sizeof(char));
          strcpy(spath_idx1_cpy,ss_curdir);
          strcat(spath_idx1_cpy,book -> G_kentel -> spath_idx1 + 1);
       }else{//if(*(book -> G_kentel -> spath_idx1) == '.' &&
          l1 =  strlen(book -> G_kentel -> spath_idx1) ;
          spath_idx1_cpy = g_malloc((l1+5)*sizeof(char));
          spath_found_cpy = g_malloc((l1+6)*sizeof(char));
          spath_idx0_cpy = g_malloc((l1+5)*sizeof(char));
          strcpy(spath_idx1_cpy,book -> G_kentel -> spath_idx1 );
       }//if(*(book -> G_kentel -> spath_idx1) == '.' &&
/*
 *
 */
       RM_ALL_BLANCS(spath_idx1_cpy);
       if((dip = opendir(spath_idx1_cpy)) == NULL){
          CREATE_DIR_IF(fp_log,spath_idx1_cpy);
       }//if((dip = opendir(spath_idx1_cpy)) == NULL){
       strcpy(spath_idx0_cpy,spath_idx1_cpy);
       strcpy(spath_found_cpy,spath_idx1_cpy);
//       scpy = strstr(spath_idx0_cpy,"IDX1");
       iscpy =  STR_STR_END0(spath_idx0_cpy,"IDX1");
       if(iscpy ){
          ll = strlen(spath_idx0_cpy)-1;
          *(spath_idx0_cpy + ll) = '0';
          CREATE_DIR_IF(fp_log,spath_idx0_cpy);
          ll = ll-3 ;
          *(spath_found_cpy + ll) = '\0';
          strcat(spath_found_cpy,"FOUND");
//          CREATE_DIR_IF(fp_log,spath_found_cpy);
       }else{//if(iscpy )
          *(spath_idx0_cpy) = '\0' ;
          *(spath_found_cpy) = '\0' ;
       }//if(scpy != NULL)
    }else{//if(i_idx1 == 1)
          spath_idx1_cpy = g_malloc(5*sizeof(char));
          spath_idx0_cpy = g_malloc(5*sizeof(char));
          spath_found_cpy = g_malloc(5*sizeof(char));
          *(spath_idx1_cpy) = '\0' ;
          *(spath_idx0_cpy) = '\0' ;
          *(spath_found_cpy) = '\0' ;
    }//if(i_idx1 == 1)
    printf("spath_idx1_ori=%s@@@ \n",spath_idx1_ori);
    printf("spath_idx1_cpy=%s@@@ \n",spath_idx1_cpy);
    printf("spath_idx0_cpy=%s@@@ \n",spath_idx0_cpy);
    l_idx1_ori = strlen(spath_idx1_ori);
    l_idx1_cpy = strlen(spath_idx1_cpy);
/*
*  Main loop on the number of lessons
*/
    nb_lesson = (*G_dico).nb_lesson ;
    fprintf(fp_log,"IMPORT number of lessons to be imported : %d \n",\
               nb_lesson);
    fflush(fp_log);
    printf("IMPORT number of lessons to be imported : %d \n",\
               nb_lesson);
    fflush(stdout);
    if(nb_lesson <= 0)return;
    for (iless = 1 ; iless <= nb_lesson ; ++iless){
       s_alias = S_ALIAS_FROM_NUM(iless, G_dico);
       printf("iless=%d s_alias=%s@@@@ \n",iless,s_alias);
       fflush(stdout);
//       fprintf(fp_log,"IMPORT iless=%d s_alias=%s@@@@ \n",iless,s_alias);
       j = strlen(s_alias) + 2 ;
       ss_alias = g_malloc((j+5)*sizeof(char));
       strcpy(ss_alias," ");
       strcat(ss_alias,s_alias);
       strcat(ss_alias," ");
       if(strstr(book -> G_kentel -> st_alias,ss_alias) != NULL){
          printf("lesson %s already exists skipped ! \n",ss_alias);
          fprintf(fp_log,"IMPORT lesson %s already exists skipped ! \n",ss_alias);
          g_free(s_alias);
          g_free(ss_alias);
       stpath_lesson = S_LESSON_FROM_NUM(iless, G_dico); 
/*     printf("skipped stpath_lesson=%s@@@ \n",stpath_lesson);
       relativ = REL_PATH_IF(&stpath_lesson,spath_of_conf);
       printf("skipped relativ=%d stpath_lesson=%s@@@ \n",relativ,stpath_lesson);*/
          continue;
       }//if(strstr() != NULL)
       stpath_lesson = S_LESSON_FROM_NUM(iless, G_dico); 
       relativ = REL_PATH_IF(&stpath_lesson,spath_of_conf);
//       s_lesson = RM_PATH_FROM_STRING(stpath_lesson);
       s_lesson = FILENAME_FROM_PATH( stpath_lesson);
       path_dirless = PATH_FROM_STRING_FILE(stpath_lesson);
       if(relativ >= 0){
          s_dirless = g_malloc((strlen(path_dirless)+5)*sizeof(char));
          strcpy(s_dirless,path_dirless);
          *s_dirless = ' ';
       }else{//if(relativ >= 0)
          s_dirless = g_malloc((+5)*sizeof(char));
          *s_dirless = '\0';
       }//if(relativ >= 0)
       RM_ALL_BLANCS(s_dirless);
       g_free(stpath_lesson ); //necessary because stpath_lesson was changed
       stpath_lesson = S_LESSON_FROM_NUM(iless, G_dico); 
       printf("stpath_lesson=%s@@@ \n",stpath_lesson);
       printf("s_lesson=%s@@@ \n",s_lesson);
       printf("path_dirless=%s@@@ \n",path_dirless);
       printf("s_dirless=%s@@@ \n",s_dirless);
       printf("s_dirconf=%s@@@ \n",s_dirconf);
/*
 *    s_dirconf is the name of the directory containing the given config file
 *                but not its absolute path which is spath_of_conf
 *    s_dirless is the name of the directory containing the lesson to be 
 *    copied
 */
       if(relativ < 0){
          printf("Transfering in present FOUND directory \n");
          lst = strlen(spath_found_cpy) + 6 + strlen(s_lesson) ; 
          stpath_dup = g_malloc((lst+5)*sizeof(char));
          strcpy(stpath_dup,spath_found_cpy) ;
          CREATE_DIR_IF(fp_log,stpath_dup);
          strcat(stpath_dup,"/") ;
          strcat(stpath_dup,s_lesson) ;
          printf("stpath_dup=%s@@@ \n",stpath_dup);
          fprintf(fp_log,"IMPORT iless=%d s_alias=%s@@@@ \n",iless,s_alias);
          copier_fichier(stpath_lesson, stpath_dup) ;
       }else{//if(relativ < 0)
          lst = strlen(ss_curdir) + strlen(s_dirless) + strlen(s_lesson) ; 
          stpath_dup = g_malloc((lst+10)*sizeof(char));
          strcpy(stpath_dup,ss_curdir) ;
          strcat(stpath_dup,s_dirless) ;
          printf("stpath_dupdir=%s@@@ \n",stpath_dup);
          CREATE_DIR_IF(fp_log,stpath_dup);
          strcat(stpath_dup,"/") ;
          strcat(stpath_dup,s_lesson) ;
          printf("stpath_duplesson=%s@@@ \n",stpath_dup);
          fprintf(fp_log,"IMPORT iless=%d s_alias=%s@@@@ \n",iless,s_alias);
          printf("call copier_fichier stpath_lesson=%s@@@ \n stpath_dup=%s@@@ \n",stpath_lesson,stpath_dup);
          copier_fichier(stpath_lesson, stpath_dup) ;
       }//if(relativ < 0)
       ss_sndfile = SOUND_FILES_FROM_LESSON(stpath_lesson,&nb_sndfile);
       if(nb_sndfile > 0 ){
/*
 *     we must make use of :
 *     stpath_lesson :  full path of original lesson
 *     stpath_dup  :  full path of copied lesson
 *     spath_found_cpy : full path of FOUND directory
 *     spath_of_conf : directory of conf file to be imported
 *     ss_curdir : current directory
 *     s_sndfile : name of the sound file
 */
          isndwav = 0 ;
          for(num = 1 ; num <= nb_sndfile ; ++num){
            s_sndfile = S_FROM_NUM(num, ss_sndfile);
            printf("name of sndfile=%s@@@@ \n",s_sndfile);
            IMPORT_SND_FILE(fp_log,s_sndfile,\
            stpath_lesson,stpath_dup, spath_of_conf,ss_curdir\
                    ,relativ,spath_found_cpy);
            if( !STR_STR_END0(s_sndfile,".wav") && isndwav == 1){
               l = strlen(s_sndfile);
               i = l-1;
               while(i > 0 && *(s_sndfile + i) != '.')--i ;
               *(s_sndfile + i + 1 ) = '\0';
               strcat(s_sndfile,"wav");
               IMPORT_SND_FILE(fp_log,s_sndfile,\
               stpath_lesson,stpath_dup, spath_of_conf,ss_curdir\
                    ,relativ,spath_found_cpy);
            }//if( !STR_STR_END0(s_sndfile,".wav"))
            g_free(s_sndfile);
          }//for(num = 1 ; num <= nb_sndfile ; ++num)
       }//if(nb_sndfile > 0 )
/*
 *     Copy of the idx1 files
 */
       l = strlen(s_lesson);
       l1 = l + l_idx1_ori + 7;
       s_idx1_ori = g_malloc((l1+5)*sizeof(char));
       strcpy(s_idx1_ori,spath_idx1_ori) ;
       strcat(s_idx1_ori,"/idx1_") ;
       strcat(s_idx1_ori,s_lesson) ;
       l1 = l + l_idx1_cpy + 7;
       s_idx1_cpy = g_malloc((l1+5)*sizeof(char));
       strcpy(s_idx1_cpy,spath_idx1_cpy) ;
       strcat(s_idx1_cpy,"/idx1_") ;
       strcat(s_idx1_cpy,s_lesson) ;
       printf("s_idx1_ori=%s@@@@ \n",s_idx1_ori);
       printf("s_idx1_cpy=%s@@@@ \n",s_idx1_cpy);
       copier_fichier(s_idx1_ori, s_idx1_cpy) ;
       scpy = strstr(s_idx1_cpy,"IDX1");
       if(scpy != NULL){
          *(scpy+3) = '0' ;
          copier_fichier(s_idx1_ori, s_idx1_cpy) ;
       }//if(scpy != NULL)
/*
 *
 */
       g_free(s_idx1_ori);
       g_free(s_idx1_cpy);
       g_free(ss_sndfile);
       g_free(stpath_dup);
       g_free(path_dirless);
       g_free(s_dirless);
       g_free(stpath_lesson);
       g_free(s_lesson);
       g_free(s_alias);
       g_free(ss_alias);
    }//for (iless = 1 ; iless <= nb_lesson ; ++iless){
/*
*  End of Main loop on the number of lessons
*/
/*
 *   Treatment of the log directory
 */
    printf("l_idx1_ori=%d spath_idx1_ori=%s@@@ \n",l_idx1_ori,spath_idx1_ori);
    printf("l_idx1_cpy=%d spath_idx1_cpy=%s@@@ \n",l_idx1_cpy,spath_idx1_cpy);
    l = l_idx1_ori -4 ;
    *(spath_idx1_ori+l) = '\0';
    strcat(spath_idx1_ori,"LOG");
    printf("spath_LOG_ori=%s@@@@ \n",spath_idx1_ori);
    if((dip = opendir(spath_idx1_ori)) != NULL){
       l = l_idx1_cpy -4 ;
       *(spath_idx1_cpy+l) = '\0';
       strcat(spath_idx1_cpy,"LOG");
       printf("spath_LOG_cpy=%s@@@@ \n",spath_idx1_cpy);
       if((dip = opendir(spath_idx1_cpy)) == NULL){
          CREATE_DIR_IF(fp_log,spath_idx1_cpy);
          l1 =  l_idx1_ori + 12;
          s_idx1_ori = g_malloc((l1+5)*sizeof(char));
          strcpy(s_idx1_ori,spath_idx1_ori) ;
          strcat(s_idx1_ori,"/diaou_rec_qr") ;
          l1 =  l_idx1_cpy + 12;
          s_idx1_cpy = g_malloc((l1+5)*sizeof(char));
          strcpy(s_idx1_cpy,spath_idx1_cpy) ;
          strcat(s_idx1_cpy,"/diaou_rec_qr") ;
          copier_fichier(s_idx1_ori, s_idx1_cpy) ;
          lcpy = strlen(s_idx1_cpy);
          *(s_idx1_cpy+lcpy-1) = '0';
          START_OF_DIAOU_REC(fp_log,s_idx1_ori,s_idx1_cpy);
          l1 = strlen(s_idx1_ori) -2 ;
          *(s_idx1_ori+l1) = 'r';
          *(s_idx1_ori+l1+1) = 'q';
          l1 = strlen(s_idx1_cpy) -2 ;
          *(s_idx1_cpy+l1) = 'r';
          *(s_idx1_cpy+l1+1) = 'q';
          copier_fichier(s_idx1_ori, s_idx1_cpy) ;
          lcpy = strlen(s_idx1_cpy);
          *(s_idx1_cpy+lcpy-1) = '0';
          START_OF_DIAOU_REC(fp_log,s_idx1_ori,s_idx1_cpy);
          g_free(s_idx1_ori);
          g_free(s_idx1_cpy);
       }else{//((dip = opendir(spath_idx1_cpy)) == NULL)
          l1 =  l_idx1_ori + 12;
          s_idx1_ori = g_malloc((l1+5)*sizeof(char));
          strcpy(s_idx1_ori,spath_idx1_ori) ;
          strcat(s_idx1_ori,"/diaou_rec_qr") ;
          l1 =  l_idx1_cpy + 12;
          s_idx1_cpy = g_malloc((l1+5)*sizeof(char));
          s_idx1_cp0 = g_malloc((l1+5)*sizeof(char));
          strcpy(s_idx1_cpy,spath_idx1_cpy) ;
          strcat(s_idx1_cpy,"/diaou_rec_qr") ;
          ADD_TO_DIAOU_REC(fp_log,s_idx1_ori,s_idx1_cpy);
          strcpy(s_idx1_cp0,s_idx1_cpy);
          lcpy = strlen(s_idx1_cpy);
          *(s_idx1_cp0+lcpy-1) = '0';
          START_OF_DIAOU_REC(fp_log,s_idx1_cpy,s_idx1_cp0);
//
          l1 = strlen(s_idx1_ori) -2 ;
          *(s_idx1_ori+l1) = 'r';
          *(s_idx1_ori+l1+1) = 'q';
          l1 = strlen(s_idx1_cpy) -2 ;
          *(s_idx1_cpy+l1) = 'r';
          *(s_idx1_cpy+l1+1) = 'q';
          ADD_TO_DIAOU_REC(fp_log,s_idx1_ori,s_idx1_cpy);
          strcpy(s_idx1_cp0,s_idx1_cpy);
          lcpy = strlen(s_idx1_cpy);
          *(s_idx1_cp0+lcpy-1) = '0';
          START_OF_DIAOU_REC(fp_log,s_idx1_cpy,s_idx1_cp0);
          g_free(s_idx1_ori);
          g_free(s_idx1_cpy);
          g_free(s_idx1_cp0);
       }//if((dip = opendir(spath_idx1_cpy)) == NULL)
    }//if((dip = opendir(spath_idx1_ori)) != NULL)
/*
 */
    g_free(spath_of_conf);
    g_free(G_dico);
    g_free(ss_curdir);
    g_free(s_dirconf);
    g_free(spath_idx1_ori);
    g_free(spath_idx1_cpy);
    g_free(spath_idx0_cpy);
    g_free(spath_found_cpy);
/*
 */
       strcpy(word_internat,"#import-1");
       ss1 = RECUP_INTERNAT_WORD( book->fp_log, word_internat,\
         1,book -> G_internat);
        Info = gtk_message_dialog_new(GTK_WINDOW(book -> pWindow),\
        GTK_DIALOG_MODAL,GTK_MESSAGE_WARNING,\
        GTK_BUTTONS_OK,ss1,NULL);
        g_free(ss1);
        gtk_dialog_run(GTK_DIALOG(Info));
        gtk_widget_destroy(Info);
//        g_free(s_trf);
    exit(0);
}/*====================    end   of IMPORT    =======================*/
/***********************************************************************/
static void      EIL_FURCH_SET(FILE *fp_log,FILE *fp,char *s_shift,\
        Trf_string *G_dico)
/*
 *     This sub is there to read the file diaou.conf
 *     where many parameters of the windows are set
 */     
{ /**  beginning of EIL_FURCH_SET  **/
char s[150],*st;
char *order[]={ "Pages", \
"Coef_Err",\
"Level_dico",\
"Width_pix_dico",\
"Width_pix_vocab",\
"Width_char_dico",\
"Color_0_dico",\
"Color_1_dico",\
"Color_2_dico",\
"Color_3_dico",\
"Color_4_dico",\
"Horiz_pix_total",\
"Verti_pix_total", \
"Font_lesson", \
"Font_vocab", \
"Which_lesson",\
"Path_idx1",\
"Lang",\
};
int i,j,l,i_order ;
int lnmx,ln,nbt_lesson,nlpath;

      
/*(*G_dico).lenmx_string = 150 ;
G_dico -> st_dico = malloc((*G_dico).lenmx_string * sizeof(char));*/
/*strcpy(G_dico -> st_dico,"./dico1_quere  ./s1_dico1_quere ./s2_dico1_quere");
printf("st_dico=%s@@@ \n",G_dico -> st_dico);
(*G_dico).nb_dico = 3;*/
   printf("entering EIL_FURCH_SET \n");
   fflush(stdout);
/*
*/
     nlpath = 10;
     (*G_dico).spath_idx1 = g_malloc((nlpath+5)*sizeof(char));
     strcpy((*G_dico).spath_idx1,"./IDX1");

/*   printf("call fopen diaou.conf \n");
   fflush(stdout);*/
   while (fgets(s,150,fp) != NULL ){
//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
       l=strcspn(s,"\r\n\0");
       s[l]='\0';
/*       printf("s=%s \n",s);
	 fflush(stdout);*/
      i=0 ;
      while(s[i] == ' ')++i; /** eliminate first blancs **/
//      printf("EIL_FURCH_SET s+i=%s@@@ \n",s+i);
      if(s[i] != '#'){
//         printf("EIL_FURCH_SET s+i=%s@@@ \n",s+i);
	 i_order= -1;
	 for(j=0 ; j <= 17 && i_order < 0 ; ++j){
	    st= strstr( s+i, order[j]);
	    if(st != NULL){
	       i_order=j;
	    }/*if(st != NULL){ */
	 }/**for(j=0 ; j <= 10 && i_order < 0 ; ++j){**/
	 printf("i_order=%d \n",i_order);
	 fflush(stdout);
	 if(i_order >= 0){
/*	   printf("s=%s order=%d \n",s,i_order);  */
	   if(i_order == 0)JUMP(fp);

	   if(i_order == 1 && strstr(s,"<:") == NULL )JUMP(fp);
	   if(i_order == 4 && strstr(s,"<:") == NULL )JUMP(fp);
	   if(i_order == 6 && strstr(s,"<:") == NULL )JUMP(fp);
	   if(i_order == 12 && strstr(s,"<:") == NULL )JUMP(fp);
	   if(i_order == 13 && strstr(s,"<:") == NULL )JUMP(fp);
          /*	   */
	  
	   if(i_order == 15){
/*
 * Attention : it has been necessary to use pointers of pointers 
 *     &(G_dico -> st_dico) to allow for the creation of the address
 *     G_dico -> st_dico into a subroutine
 */     
	      EXTRACT_WHICH_LESSONS(fp_log,fp,s_shift,s,G_dico );
	      ln=0;
/*	      printf("G_dico -> st_dico = %s@@@ \n",G_dico -> st_dico);
	      printf("ln=%d lnmx=%d \n",ln,lnmx);*/
	      ln=strlen((*G_dico).st_lesson);
	      (*G_dico).st_lesson[ln]=' ';
	      ++ln;
	      (*G_dico).st_lesson[ln]='\0';
	      ++ln;
/*	      printf("ln=%d lnmx=%d \n",ln,lnmx);*/
	      lnmx = (*G_dico).lenmx_string;
	      if(ln < lnmx){/*adjutment of string length to spare memory*/
		 lnmx=ln;
		 G_dico -> st_lesson = g_realloc( G_dico -> st_lesson,\
				 lnmx*sizeof(char));
	         (*G_dico).lenmx_string = lnmx;
	      }/* if(ln < lnmx){*/
/*	      printf("G_dico -> st_dico =%s@@@ \n",G_dico -> st_dico);
	      printf("(*G_dico).nb_dico = %d \n",(*G_dico).nb_dico);
	      printf("(*G_dico).lenmx_string=%d \n",(*G_dico).lenmx_string);*/
	   }/*if(i_order == 15){*/
	   if(i_order == 16){
	      EXTRACT_PATH_IDX1(fp,s,&nlpath,&((*G_dico).spath_idx1));
	      printf("spath_idx1=%s@@@@@@ \n",(*G_dico).spath_idx1);
	   }/*if(i_order == 2){*/
	 }else{/*if(i_order >= 0){*/
	   printf("s=%s order unknown =%d \n",s,i_order);
	      exit(0);
      i=0 ;
	 }/*if(i_order >= 0){*/
      }/* end of if(s[i] != '#'){   */
   }/*while (fgets(s,100,fp) != NULL ){*/
      KLASK_NB_PAJ(&nbt_lesson, G_dico->st_lesson,s);
} /**  end of EIL_FURCH_SET  **/
/***********************************************************************/
static void JUMP(FILE *fp)
{ /**  beginning of JUMP  **/
char s[150];
int i;
   i = 1;
   while ( i > 0 ){
        if(fgets(s,150,fp) == NULL ){
           i = 0;
        }else{//if(fgets(s,150,fp) == NULL ){
           if(strstr(s,"<:") != NULL)i = 0;
        }//if(fgets(s,150,fp) == NULL ){
   }//while ( i > 0 ){
   return ;
} /**  end of JUMP  **/
 /*################################################################*/
   char *SOUND_FILES_FROM_LESSON(char *stpath_lesson, int *nb_sndfile)
/*
 *    On output this function gives the names of the sound files
 *    included into the lesson : stpath_lesson (le path complet de
 *    la lecon)
 *    We also output the number of sound files found.
 *    
 */
 {
 char c, *ss_sndf=NULL,*stp, *ss, *sse ;
 int lsndf,ii,i_page,i_page1,i,j,k,l,lss ;
 int i0,i1 ;
 long int nc,nbytes,nbyt,nb_lu ;
 FILE *fp ;
    *nb_sndfile = 0 ;
    lsndf = 20 ;
    ss_sndf = g_malloc((lsndf+5)*sizeof(char));
    *(ss_sndf) = ' ' ;
    *(ss_sndf+1) = '\0' ;
     fp = fopen(stpath_lesson,"r");
     if(fp == NULL){
        g_free(ss_sndf); ss_sndf = NULL ;
        return(ss_sndf) ;
     }//if(fp == NULL){
     nbytes = 100 ;
     ss = g_malloc((nbytes+5)*sizeof(char));
     nbyt = 100 ;
     sse = g_malloc((nbyt+5)*sizeof(char));
	ii=0;
	i_page = 0;
        nc = 0;
	while(ii < 10000 && i_page == 0  ){
	   ++ii;
	   nb_lu = aln_getline(&nc,&ss,&nbytes,fp);
	   if(nb_lu == -2 || strstr(ss,"END_OF_FILE") != NULL ){
	      i_page = 1;
	      continue;
	   }/*if(nb_lu == -2){*/
           stp = NULL;
           if((stp = strstr(ss,"<))")) != NULL ){
              l = strlen(stp);
              j = 0 ;
              *(sse+j) = ' ' ;
              i = 3 ;
              while( i < l && *(stp+i) == ' '  )++i;
              i0 = i;
              for (i = i0  ; i < l && (c = *(stp+i)) != ' ' ; ++i ){
                 ++j ;
                 if(j >= nbyt){
                    nbyt = j + 50 ;
                    sse = g_realloc(sse,(nbyt+5)*sizeof(char));
                 }//if(j >= nbyt)
                 *(sse+j) = c ;
              }//for (i = 3 ; i < l && (c = *(stp+i)) != ' ' )
              ++j ; *(sse+j) = ' ' ;
              ++j ; *(sse+j) = '\0' ;
              if(strstr(ss_sndf,sse) == NULL){
                 lss = strlen(ss_sndf) - 1 ;
                 *(ss_sndf+ lss) = '\0' ;
                 k = lss + j + 1 ;
                 if(k >= lsndf){
                    lsndf = k + 50 ;
                    ss_sndf = g_realloc(ss_sndf,(lsndf+5)*sizeof(char));
                 }//if(j >= nbyt)
                 strcat(ss_sndf,sse);
                 *nb_sndfile = *nb_sndfile + 1 ;
              }//if(strstr(ss_sndf,sse) == NULL)
              continue;
           }//if((stp = strstr(ss,"<))")) != NULL )
/**************/
           if((stp = strstr(ss,"<)start)")) != NULL ){
              i_page1 = 0 ;
	      while(ii < 10000 && i_page1 == 0  ){
	         ++ii;
	         nb_lu = aln_getline(&nc,&ss,&nbytes,fp);
	         if(nb_lu == -2 || strstr(ss,"END_OF_FILE") != NULL ){
	            i_page = 1;
	            i_page1 = 1;
	            continue;
	         }/*if(nb_lu == -2)*/
                 stp = NULL;
                 if((stp = strstr(ss,"<)end)")) != NULL ){
	            i_page1 = 1;
	            continue;
                 }//if((stp = strstr(ss,"<)end)")) != NULL )
                 if( PERHAPS_BUTTON(ss, &i0, &i1)){
                    l = strlen(ss);
                    j = 0 ;
                    *(sse+j) = ' ' ;
                    i = i1 + 1 ;
                    while( i < l && *(ss+i) == ' '  )++i;
                    i0 = i ;
                    for (i = i0 ; i < l && (c = *(ss+i)) != ' ' ; ++i ){
                       ++j ;
                       if(j >= nbyt){
                          nbyt = j + 50 ;
                          sse = g_realloc(sse,(nbyt+5)*sizeof(char));
                       }//if(j >= nbyt)
                       *(sse+j) = c ;
                    }//for (i = 3 ; i < l && (c = *(stp+i)) != ' ' )
                    ++j ; *(sse+j) = ' ' ;
                    ++j ; *(sse+j) = '\0' ;
                    if(strstr(ss_sndf,sse) == NULL){
                       lss = strlen(ss_sndf) - 1 ;
                       *(ss_sndf+ lss) = '\0' ;
                       k = lss + j + 1 ;
                       if(k >= lsndf){
                          lsndf = k + 50 ;
                          ss_sndf = g_realloc(ss_sndf,(lsndf+5)*sizeof(char));
                       }//if(j >= nbyt)
                       strcat(ss_sndf,sse);
                       *nb_sndfile = *nb_sndfile + 1 ;
                    }//if(strstr(ss_sndf,sse) == NULL)
                 }//if( PERHAPS_BUTTON(ss, &i0, &i1))
	      }//while(ii < 10000 && i_page == 0  )
           }//if((stp = strstr(ss,"<)start)")) != NULL )
	}//while(ii < 10000 && i_page == 0  )
     lss = strlen(ss_sndf) ;
     ss_sndf = g_realloc(ss_sndf,(lss+5)*sizeof(char));
     g_free(ss);
     g_free(sse);
     fclose(fp);
     printf("SOUND_FILE_FROM_LESSON ss_sndf=%s@@@@ \n",ss_sndf);
     return(ss_sndf) ;
 }

/*##################################################################*/
char   *S_FROM_NUM(int num, char *st_alias) 
/*
 *    input num place of the lessons  
 *    output  s_alias string of the alias for this lesson
 */
{//==========Start of S_FROM_NUM===============================
char *s;
int i,ii,j,k,l;
   if(num <= 0){
      s = NULL;
      return(s);
   }//if(num <= 0){
   l = strlen(st_alias);
   j = 0;
   i = 0;
   while(j < num && i < l){
      while(i < l && *(st_alias+i) == ' ')++i;
      ++j;
      if(j >= num)continue;
      while(i < l && *(st_alias+i) != ' ')++i;
   }//while(j < num && i < l){
   if(j < num ){
      s = NULL;
      return(s);
   }//if(num <= 0){
   j = i;
   while(j < l && *(st_alias+j) != ' ')++j;
   l = j-i+1;
   s = g_malloc((l+5)*sizeof(char));
   ii = 0;
   for(k = i; k < j ; ++k){
      *(s+ii)= *(st_alias + k);
      ++ii;
   }//for(k = i; k < j ; ++k){
   *(s+ii) = '\0';
   return(s);
}//==========End of S_FROM_NUM===============================
 /*################################################################*/
static void  IMPORT_SND_FILE(FILE *fp_log,char *s_sndfile,\
    char *stpath_lesson,char *stpath_dup, char *s_dirconf, char *ss_curdir,\
       int relativ,char *s_found)
/*
 *     we must make use of :
 *     stpath_lesson :  full path of original lesson
 *     stpath_dup  :  full path of copied lesson
 *     s_dirconf:full path of directory where is the conf file to be imported
 *     relativ < 0  put the sound file into the directory FOUND 
 *            whose full path is in s_found
 *     ss_curdir : current directory
 *     s_sndfile : name of the sound file
 */
/*
 *    This sub will try to find the true PATH+name of the
 *    sound file and if found copy it in an appropriate place
 *
 */
{//==========Start of IMPORT_SND_FILE =========================
int  ll,ll1,ll2,lsnd,i2,j,k,rtn;
static int i1 = 1;
FILE  *fps;
char *path_of_lesson, *s_sound_ori, *s_sound_cpy ;
/*   char *stp ;
        stp = strstr(ss,".ogg");
	if(stp != NULL)strcpy(stp,".wav");*/
        path_of_lesson = PATH_FROM_STRING(stpath_lesson);
        ll1 = strlen(path_of_lesson);
        ll2 = strlen(s_dirconf);
        ll = ll1 ; if(ll2 > ll1)ll= ll2;
	lsnd= strlen(s_sndfile) + ll + 8 ;
	s_sound_ori = g_malloc((lsnd+5)*sizeof(char));
	i2 = i1+4;
        rtn = 0 ;
	for(k= i1 ; rtn == 0 && k <= i2 ; ++k){
           j = k;
	   while(j > 4)j=j-4;
	   switch (j) {
	      case 1://path_of_lesson+file_name
	         strcpy(s_sound_ori,path_of_lesson);
//	         strcat(s_sound_ori,"/");
	         strcat(s_sound_ori,s_sndfile);
                 fps = fopen(s_sound_ori,"r");
                 if(fps != NULL){
	            fclose(fps);
                    printf("IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(stdout);
                    fprintf(fp_log,"IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(fp_log);
                    rtn = 1 ;
		    i1 = j ;
                 }//if(fps == NULL){
	         break;
	      case 2://   ./file_name
	         strcpy(s_sound_ori,s_dirconf);
//	         strcat(s_sound_ori,"/");
	         strcat(s_sound_ori,s_sndfile);
                 fps = fopen(s_sound_ori,"r");
                 if(fps != NULL){
	            fclose(fps);
                    printf("IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(stdout);
                    fprintf(fp_log,"IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(fp_log);
	            rtn = 2 ;
		    i1 = j ;
                 }//if(fps == NULL){
	         break;
              case 3://  ./SOUND/file_name
	         strcpy(s_sound_ori,s_dirconf);
	         strcat(s_sound_ori,"SOUND/");
	         strcat(s_sound_ori,s_sndfile);
                 fps = fopen(s_sound_ori,"r");
                 if(fps != NULL){
	            fclose(fps);
                    printf("IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(stdout);
                    fprintf(fp_log,"IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(fp_log);
	            rtn = 3 ;
		    i1 = j ;
                 }//if(fps == NULL){
	         break;
	      case 4://   path_of_lesson/SOUND/file_name
	         strcpy(s_sound_ori,path_of_lesson);
	         strcat(s_sound_ori,"SOUND/");
	         strcat(s_sound_ori,s_sndfile);
                 fps = fopen(s_sound_ori,"r");
                 if(fps != NULL){
	            fclose(fps);
                    printf("IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(stdout);
                    fprintf(fp_log,"IMPORT_SND_FILE can open file=%s@@@@ \n",s_sound_ori);
	            fflush(fp_log);
	            rtn = 4 ;
		    i1 = j ;
                 }//if(fps == NULL){
	         break;
           }// end of switch i0_extracted[1] {
	}//for(k= i1 ; k <= i2 ; ++k){
        g_free(path_of_lesson);
        if(rtn == 0){
           printf("IMPORT_SND_FILE cannot find sndfile=%s@@@ \n",s_sndfile);
           fprintf(fp_log,"IMPORT_SND_FILE cannot find sndfile=%s@@@ \n",s_sndfile);
           g_free(s_sound_ori);
           return;
        }//if(rtn == 0){
        if(relativ < 0 ){
           ll = strlen(s_found) + strlen(s_sndfile);
	   s_sound_cpy = g_malloc((ll+5)*sizeof(char));
	   strcpy(s_sound_cpy,s_found);
	   strcat(s_sound_cpy,"/");
	   strcat(s_sound_cpy,s_sndfile);
           copier_fichier(s_sound_ori, s_sound_cpy) ;
           fprintf(fp_log,"IMPORT_SND_FILE cpy sound file at=%s@@@@ \n",s_sound_cpy);
           g_free(path_of_lesson);
           g_free(s_sound_ori);
           g_free(s_sound_cpy);
           return;
        }//if(relativ < 0 ){
        path_of_lesson = PATH_FROM_STRING(stpath_dup);
        ll1 = strlen(path_of_lesson);
        ll2 = strlen(ss_curdir);
        ll = ll1 ; if(ll2 > ll1)ll= ll2;
	lsnd= strlen(s_sndfile) + ll + 8 ;
	s_sound_cpy = g_malloc((lsnd+5)*sizeof(char));
	   switch (rtn) {
	      case 1://path_of_lesson+file_name
	         strcpy(s_sound_cpy,path_of_lesson);
	         strcat(s_sound_cpy,"/");
	         strcat(s_sound_cpy,s_sndfile);
                 copier_fichier(s_sound_ori, s_sound_cpy) ;
            fprintf(fp_log,"IMPORT_SND_FILE  cpy sound file at=%s@@@@ \n",s_sound_cpy);
                 fflush(fp_log);
            printf("IMPORT_SND_FILE case 1 cpy sound file at=%s@@@@ \n",s_sound_cpy);
	         break;
	      case 2://   ./file_name
	         strcpy(s_sound_cpy,ss_curdir);
//	         strcat(s_sound_cpy,"/");
	         strcat(s_sound_cpy,s_sndfile);
                 copier_fichier(s_sound_ori, s_sound_cpy) ;
            fprintf(fp_log,"IMPORT_SND_FILE cpy sound file at=%s@@@@ \n",s_sound_cpy);
            printf("IMPORT_SND_FILE case 2 cpy sound file at=%s@@@@ \n",s_sound_cpy);
                 fflush(fp_log);
	         break;
              case 3://  ./SOUND/file_name
	         strcpy(s_sound_cpy,ss_curdir);
	         strcat(s_sound_cpy,"SOUND/");
                 CREATE_DIR_IF(fp_log,s_sound_cpy);
	         strcat(s_sound_cpy,s_sndfile);
                 copier_fichier(s_sound_ori, s_sound_cpy) ;
            fprintf(fp_log,"IMPORT_SND_FILE cpy sound file at=%s@@@@ \n",s_sound_cpy);
            printf("IMPORT_SND_FILE case 3 cpy sound file at=%s@@@@ \n",s_sound_cpy);
                 fflush(fp_log);
	         break;
	      case 4://   path_of_lesson/SOUND/file_name
	         strcpy(s_sound_cpy,path_of_lesson);
	         strcat(s_sound_cpy,"SOUND/");
                 CREATE_DIR_IF(fp_log,s_sound_cpy);
	         strcat(s_sound_cpy,s_sndfile);
                 copier_fichier(s_sound_ori, s_sound_cpy) ;
            fprintf(fp_log,"IMPORT_SND_FILE cpy sound file at=%s@@@@ \n",s_sound_cpy);
            printf("IMPORT_SND_FILE case 4 cpy sound file at=%s@@@@ \n",s_sound_cpy);
                 fflush(fp_log);

	         break;
           }// end of switch rtn

        g_free(path_of_lesson);
        g_free(s_sound_ori);
        g_free(s_sound_cpy);
}//==========End of IMPORT_SND_FILE ===========================

/*##################################################################*/
void   ADD_TO_DIAOU_REC(FILE *fp_log,char *s_diaou_rec_ori,\
       char *s_diaou_rec_cpy)
/*
 *    this sub will add the contains of s_diaou_rec_ori to 
 *    the end of s_diaou_rec_cpy  
 */
{//==========Start of ADD_TO_DIAOU_REC===============================
FILE *fp_rec,*fp_ori;
char *ssd;
long int nc,ncp,nb_lu,nbytes,i_extracted[12] ;
long int ncp0,i_page ;
int j;
   printf("sub ADD_TO_DIAOU_REC file s_diaou_rec_ori=%s@@@ \n",s_diaou_rec_ori);
   printf("sub ADD_TO_DIAOU_REC file s_diaou_rec_cpy=%s@@@ \n",s_diaou_rec_cpy);
   fp_rec = fopen(s_diaou_rec_cpy,"r+");
   if(fp_rec == NULL){
      copier_fichier(s_diaou_rec_ori, s_diaou_rec_cpy) ;
      return;
   }//if(fp == NULL)
       nbytes = 100;
       ssd = g_malloc((nbytes+5)*sizeof(char));
       ncp = 0 ;
       nb_lu = aln_getline(&ncp,&ssd,&nbytes,fp_rec);
       printf("sub ADD_TO_DIAOU_REC file read ssd=%s@@@ \n",ssd);
       j =  EXTR_N_LINT(1,ssd, i_extracted);
       if(i_extracted[0] != 1){
          printf("sub ADD_TO_DIAOU_REC error 1 EXTR_N_LINT \n");
          printf("ssd=%s@@@@ \n",ssd);
          fprintf(fp_log,"sub ADD_TO_DIAOU_REC error 1 EXTR_N_LINT \n");
          fprintf(fp_log,"ssd=%s@@@@ \n",ssd);
          fprintf(fp_log,"NO writing of file=%s@@@@ \n",s_diaou_rec_cpy);
          fclose(fp_rec);
          g_free(ssd);
          return;
       }//if(j != 1){
       nc = i_extracted[1];
       fseek(fp_rec,nc,0);
       fp_ori = fopen(s_diaou_rec_ori,"r");
      if(fp_ori == NULL){
          fprintf(fp_log,"NO file=%s@@@@ \n",s_diaou_rec_ori);
          fclose(fp_rec);
          g_free(ssd);
         return;
      }//if(fp == NULL)
      ncp0 = 0 ;
      i_page = 1;
      while(i_page > 0 && i_page < 100000 ){
         nb_lu = aln_getline(&ncp0,&ssd,&nbytes,fp_ori);
         if(nb_lu == -2 || strstr(ssd,"END_OF_FILE") != NULL){
            i_page = 0;
            continue;
         }/*if(nb_lu == -2){*/
         if(i_page == 1){
            ++i_page;
            continue;
         }//if(i_page == 1)
         fprintf(fp_rec,"%s\n",ssd);
         ++i_page;
      }//while(i_page > 0 && i_page < 100000 )
      CLOSE_DIAOU_REC(fp_rec);
      fclose(fp_ori);
      g_free(ssd);
      return;
}//========== End  of ADD_TO_DIAOU_REC===============================
/*##################################################################*/
void   START_OF_DIAOU_REC(FILE *fp_log,char *s_diaou_rec_ori,\
       char *s_diaou_rec_cpy)
/*
 *    this sub will extract in file s_diaou_rec_ori the first
 *    line and copy it into s_diaou_rec_cpy
 */
{//==========Start of START_OF_DIAOU_REC===============================
FILE *fp_rec,*fp_ori;
char *ssd;
long int nc,ncp,nb_lu,nbytes,i_extracted[12] ;
int j;
char  *ssnb ;
int lssnb ;
//==========================================

//==========================================
   printf("sub START_OF_DIAOU_REC file s_diaou_rec_ori=%s@@@ \n",s_diaou_rec_ori);
   printf("sub START_OF_DIAOU_REC file s_diaou_rec_cpy=%s@@@ \n",s_diaou_rec_cpy);
       lssnb = 20;
       ssnb= g_malloc((lssnb+5)*sizeof(char));
       fp_rec = fopen(s_diaou_rec_cpy,"w");
       fp_ori = fopen(s_diaou_rec_ori,"r");
      if(fp_ori == NULL){
          fprintf(fp_log,"NO file=%s@@@@ \n",s_diaou_rec_ori);
          nc = 0 ;
          LNB_12CHAR(nc,ssnb);
          fseek(fp_rec,0,0);
          fprintf(fp_rec,"%s",ssnb);
          fclose(fp_rec);
          g_free(ssnb);
         return;
      }//if(fp == NULL)
       nbytes = 100;
       ssd = g_malloc((nbytes+5)*sizeof(char));
       ncp = 0 ;
       nb_lu = aln_getline(&ncp,&ssd,&nbytes,fp_ori);
       printf("sub START_OF_DIAOU_REC file read ssd=%s@@@ \n",ssd);
       j =  EXTR_N_LINT(1,ssd, i_extracted);
       if(i_extracted[0] != 1){
          printf("sub START_OF_DIAOU_REC error 1 EXTR_N_LINT \n");
          printf("ssd=%s@@@@ \n",ssd);
          fprintf(fp_log,"sub START_OF_DIAOU_REC error 1 EXTR_N_LINT \n");
          fprintf(fp_log,"ssd=%s@@@@ \n",ssd);
          fprintf(fp_log,"NO writing of file=%s@@@@ \n",s_diaou_rec_cpy);
          fclose(fp_rec);
          fclose(fp_ori);
          g_free(ssd);
          g_free(ssnb);
          return;
       }//if(j != 1){
       nc = i_extracted[1];
       LNB_12CHAR(nc,ssnb);
       fseek(fp_rec,0,0);
       fprintf(fp_rec,"%s",ssnb);
       fclose(fp_rec);
       fclose(fp_ori);
       g_free(ssd);
       g_free(ssnb);
       return;
}//========== End  of START_OF_DIAOU_REC===============================

